﻿var option="ext_icon_use=on&use_ex_thum=0&dialog_show=always&title_align=left&title_edit=none&multi=on&movieId=on&title=on&time=on&loaded=on&sort_status=movieId_down&sort_rank=0%2C1%2C2%2C3&autosave=on";
/*
1行目はオプション画面でオプション設定後、
"設定用文字列生成"ボタンをクリックして表示された
デフォルト設定用のテキストフィールドから丸ごとコピー＆ペースト
文字化けするのでこのファイルは保存時に文字コードをUTF-8とすること

※逆にCookieしか使わない場合は消さないと干渉するかも！
*/

/*-----------------------------------------------------------------------------
変数（オプションetc.）
-----------------------------------------------------------------------------*/
var LISTX_VERSION="090319";
var COOKIE_OK=navigator.cookieEnabled;		//0かfalseにするとcookieを無効化可能
var KANA_FIX=true;							//true:カタカナをかなとしてソート,false:文字コード順にソート
var SORT_RANK=[0,1,2,3];					//順番に数字、半角文字(数字除く)、かな、その他の全角文字、のソート順序
var SORT_CHAR="";							//列挙した文字はその順番に最優先でソート
var AUTO_SAVE=true;							//クッキーへ自動保存するか（Optionから変更すべし）
var SIZE_ORDER=1;							//一時キャッシュのロード済みサイズ表示単位 0:B,1:KB,2:MB,3:GB,4:TB
var SIZE_SPLIT=true;						//true:一時キャッシュのロード済みサイズ表示を3桁カンマ区切りにする,false:しない
var TITLE_EDIT=1;							//タイトルをクリックした時に編集するか 0:しない,1:クリックで編集,2:ダブルクリックで編集
var TITLE_REPLACE_CHAR=						//タイトルに使えない文字を置き換える([['使用できない文字','代替文字'],[〃],...])
	[['#','＃'],['/','／'],[':','：'],['*','＊'],['?','？'],['"','”'],['<','＜'],['>','＞'],['|','｜']];
var DIALOG_LEFT=0;							//確認ダイアログの水平方向の表示位置（px）負数:センタリング,それ以外:list.cssの.dialogで設定
var DIALOG_SHOW=0;							//ダイアログによる確認 0:常に尋ねる,1:複数の動画を操作するときのみ尋ねる,2:常に尋ねない
var PUSHED_SHIFT=false;						//shiftキーを押しているか否か
var IMG_USE_FLAG=false;						//true:各種アイコンを表示する,false:画像の変わりに文字を表示する（falseで低負荷かつ高速になる）
var EXT_ICON_USE=false;						//true:拡張子ごとのアイコンを表示する,false:表示しない
var IMG_DEL=["resource/img/del.gif",'削',"削除"];		//削除アイコン（["ファイル名","画像を表示しないときの代替テキスト","説明"]）;
var IMG_SAVE=["resource/img/save.gif",'保',"DL"];		//保存アイコン（〃）
var IMG_MOVE=["resource/img/move.gif",'移',"移動"];		//移動アイコン（〃）
var IMG_MP3=["resource/img/audio.gif",'音',"MP3を抽出"];	//MP3アイコン（〃）
var IMG_THUM_LOADING="resource/img/loading.gif";	//サムネイルのロード中アイコン
var USE_EX_THUM=0;									//サムネイル(0:標準のサムネイル,1:外部貼り付け用サムネイル,2：player.htmlによる再生)
var THUM_WAIT=500;									//サムネイルを表示するまでの待ち時間(ms)
var THUM_WAIT_TIMER=setTimeout('',1);				//サムネイルを表示待ち用のタイマーid保存用
var ORIG_PLAYER_LINK_NWIN=true;						//USE_EX_THUM=2のとき、タイトルのリンクを新しいウィンドウで表示するか
var MULTI_LIST={};							//複数に対するコマンド時の対象リスト
var SORT_FLAG=[1,1];						//デフォルトのソート状態 [0:動画番号/1:タイトル/2:フォルダ/3:ファイルサイズ/4:更新日時,0:降順/1:昇順]
var tempList={};							//一時キャッシュリスト（未定義エラー回避用）
var pathList={};							//パスごとのキャッシュリスト（後からリスト生成するため）
var AUTOMOVE_RULE="resource/settings/autoMoveRule.xml";		//自動振り分け用ルール
var CACHE_LIMIT_RULE="resource/settings/cacheLimitRule.xml";//キャッシュ制限用ルール
var RESULT_MAX_HEIGHT=480;						//検索、削除提案時のウィンドウの高さの最大

/*-----------------------------------------------------------------------------
定数（テンプレ）
-----------------------------------------------------------------------------*/
//一時キャッシュ用
var TEMP_TEMP_TABLE=
		"<tr id='{dispHref}' class='{className}'>"+
		"<td class='multi'><input type='checkbox' onclick='addMulti(\"{dispHref}\",this.checked)'></td>"+
		"<td class='movieId{fileType}'>{del}<a href='../watch/{rightHref}' onmouseover='viewThum(this,(USE_EX_THUM-0)+10)' onmouseout='hideThum(this)' title='Shiftキーを押すと自前プレイヤーに切り替え'>{dispHref}</a></td>"+ 
		"<td class='title'><span onclick='viewTitleBox(this,1)' ondblclick='viewTitleBox(this,2)'>{title}</span>"+
		"<span><a class='tag' href='javascript:void(0)' onclick='disp(this.nextSibling)'>*</a><span style='display:none'>　{tag}<br><span style='display:none'></span></span></td>"+
		"<td class='loaded'>{status}{loaded}</td></tr>";
//以下、その他キャッシュ用
var TEMP_TABLE=
		"<tr id='{dispHref}' class='{className}'>"+
		"<td class='multi'><input type='checkbox' onclick='addMulti(\"{dispHref}\",this.checked)'></td>"+
		"<td class='movieId{fileType}'>"+
			"<span onclick='location.href=\"./{dispHref}/movie\"' class='command'>{IMG_SAVE}</span>"+
			"<span onclick='location.href=\"./{dispHref}/audio\"' class='command'>{IMG_MP3}</span>"+
			"<span onclick='delFLV({tableCnt},\"{dispHref}\")' class='command'>{IMG_DEL}</span>"+
			"<span onclick='viewMoveOption(\"{dispHref}\",\"{folder}\")' class='command'>{IMG_MOVE}</span>"+
		"<a href='../watch/{rightHref}' class='flvLink' onmouseover='viewThum(this,(USE_EX_THUM-0)+10)' onmouseout='hideThum(this)' title='Shiftキーを押すと自前プレイヤーに切り替え'>{dispHref}</a>"+
			"</td>"+
		"<td class='title'><span onclick='viewTitleBox(this,1)' ondblclick='viewTitleBox(this,2)'>{title}</span>"+
		"<span><a class='tag' href='javascript:void(0)' onclick='disp(this.nextSibling)'>*</a><span style='display:none'>　{tag}<br><span style='display:none'></span></span></td>"+
		"<td class='time'>{time}</td>"+
		"<td class='length'>{length}</td></tr>";
var TEMP_TH=
		"<tr class='tableHeader'><th class='unsortable multi' onclick='multiCheck(this)'><span class='bt_select_off'>選</span></th><th class='movieId' title='Shiftキー押しながらソートでlowを抽出かつアルファベット順にソート' onmouseover='hideThum(this,true)'>動画番号</th>"+
		"<th class='title' style='text-align:center'>タイトル</th><th class='time'>更新日時</th><th class='length'>大きさ</th></tr>";
//検索結果用
var TEMP_SEARCH_TABLE=
		"<tr id='{dispHref}' class='{className}'>"+
		"<td class='multi'><input type='checkbox' onclick='addMulti(\"{dispHref}\",this.checked)'></td>"+
		"<td class='movieId{fileType}'>"+
			"<span onclick='location.href=\"./{dispHref}/movie\"' class='command'>{IMG_SAVE}</span>"+
			"<span onclick='location.href=\"./{dispHref}/audio\"' class='command'>{IMG_MP3}</span>"+
			"<span onclick='delFLV({tableCnt},\"{dispHref}\")' class='command'>{IMG_DEL}</span>"+
			"<span onclick='viewMoveOption(\"{dispHref}\",\"{folder}\")' class='command'>{IMG_MOVE}</span>"+
		"<a href='../watch/{rightHref}' class='flvLink' onmouseover='viewThum(this,(USE_EX_THUM-0)+10)' onmouseout='hideThum(this)' title='Shiftキーを押すと自前プレイヤーに切り替え'>{dispHref}</a>"+
			"</td>"+
		"<td class='title'><span onclick='viewTitleBox(this,1)' ondblclick='viewTitleBox(this,2)'>{title}</span>"+
		"<span><a class='tag' href='javascript:void(0)' onclick='disp(this.nextSibling)'>*</a><span style='display:none'>　{tag}<br><span style='display:none'></span></span></td>"+
		"<td class='folder'>{folder}</td>"+
		"<td class='time'>{time}</td>"+
		"<td class='length'>{length}</td></tr>";
var TEMP_SEARCH_TH=
		"<tr class='tableHeader'><th class='unsortable multi' onclick='multiCheck(this)'><span class='bt_select_off'>選</span></th><th class='movieId' onmouseover='hideThum(this,true)'>動画番号</th>"+
		"<th class='title' style='text-align:center'>タイトル</th><th>folder</th><th class='time'>更新日時</th><th class='length'>大きさ</th></tr>";
/*-----------------------------------------------------------------------------
機能拡張用関数群
-----------------------------------------------------------------------------*/

//文字列中の{キー}をオブジェクトのキーに対応する値に置き換えた文字列を返す（ex："1+1={Ans}".ins({Ans:1+1})//"1+1=2"）
String.prototype.ins=function(_var){
	var str=this;
	for(var i in _var){
		str=str.split('{'+i+'}').join(_var[i]);
		//str=str.replace(new RegExp('{'+i+'}','g'),_var[i]);//とても遅い
	}
	return str;
};

//オブジェクトを配列へ変換
function toArray(obj){
	var arr=[],cnt=0;
	for(var i in obj)
		arr[cnt++]=[i].concat(obj[i]);//キーを先頭に追加
	return arr;
};

//2次元配列中のX番目を比較対象としてソート(upperSortFlag:昇順ソート)
Array.prototype.childXSort=function(X,upperSortFlag){
	var arr=this.slice(0);
	upperSortFlag=upperSortFlag?-1:1;
	arr.sort(function(a,b){
		if(X==0)return (a[X].match(/\d+/)*1-b[X].match(/\d+/)*1)*upperSortFlag;
		else return (a[X]<b[X]?-1:a[X]==b[X]?0:1)*upperSortFlag;
	});
	return arr;
};

//2次元配列中のX番目がvalのものを抽出
Array.prototype.childFillter=function(X,val){
	var arr=this.slice(0),tmp=[];
	for(var i=0,n=arr.length,cnt=0;i<n;i++)
		if(arr[i][X]==val)
			tmp[cnt++]=arr[i];
	return tmp;
};

// prototype.jsを展開
document.getElementsByClassNameAndTagName = function(className, parentElement, tagName) {
 if (!!document.evaluate) {
    var q = ".//*[contains(concat(' ', @class, ' '), ' " + className + " ')]";
	var results = [],cnt=0;
	var query = document.evaluate(q, parentElement || document,
									null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	for (var i = 0, length = query.snapshotLength; i < length; i++)
		results[cnt++]=query.snapshotItem(i);
	return results;
 } else {
	var arr = [], cnt = 0;
	var obj=parentElement.getElementsByTagName(tagName);
	for(var i=0,n=obj.length,cnt=0;i<n;i++)
		if(obj[i].className.indexOf(className)!=-1)
			arr[cnt++]=obj[i];
	return arr;
 }
} 

//指定されたクラスの設定された要素を得る
document.getByClass=function(name, tag){
	if (typeof tag == "array")
	{
		for (var i=0; i<tag.length; ++i)
			arr = arr.concat(document.getElementsByClassNameAndTagName(name, document, tag[i]));
		return arr;
	}
	
	if (typeof tag != "string")
		tag = '*';
	return document.getElementsByClassNameAndTagName(name, document, tag);
};

//指定されたidの設定された要素を得る
document.getById=function(id){
	return document.getElementById(id);
};


//クロスブラウザなイベント追加
function addEvent(ele,name,func,cap){
	if(ele){
		if(ele.attachEvent)ele.attachEvent("on"+name,func);
		else if(ele.addEventListener)ele.addEventListener(name,func,cap);
		else{
			var old_func=ele["on"+name];
			if(typeof old_func!="function")
				old_func=function(){};
			ele["on"+name]=function(){ old_func(); func(); };
		}
	}
}
//渡された数値を元にファイル数を表す文字列を返す
function fileCount(cnt){
	return (cnt>0?cnt:'')+(cnt==0?"N/A":(cnt>1?"files.":"file"));
}

//Byte表示の変更
function numViewCh(num,sizeOrder){
	num=num-0;
	for(var i=0;i<SIZE_ORDER;i++)
		num/=1024;
	num=Math.ceil(num);
	if(SIZE_SPLIT)
		num=(num+'').replace(/(\d+?)(?=(\d{3})+$)/g,"$1,");
	return num+["B","KB","MB","GB","TB"][sizeOrder||SIZE_ORDER];
}

//Dialog表示クラス
function Dialog(opt){
	/*
		var opt={
			title:"キャプション",
			str:"標準ダイアログ内に表示されるHTMLソース",
			func:function(OKボタンが押されたか{bool}){},//ボタンが押されたときのコールバック関数
			okOnly:OKボタンのみ表示{bool},
			multiFlag:複数の動画に対する操作時にtrueを指定{bool},
			alwaysAsk:すでにダイアログが表示状態でも表示する,
			originalHTML:"標準のダイアログの変わりに表示するHTMLソース",
			id:ダイアログを表示する要素のid（省略時"dialog"）,
			x:ダイアログの表示x座標,
			y:ダイアログの表示y座標
		};
	*/
	var title=opt.title,
		str=opt.str,
		func=opt.func,
		okOnly=opt.okOnly,
		multiFlag=opt.multiFlag,
		alwaysAsk=opt.alwaysAsk,
		originalHTML=opt.originalHTML,
		id=opt.id||"dialog",
		_x=opt.x,
		_y=opt.y;

	okOnly=typeof func!="function"||okOnly;
	if( (DIALOG_SHOW==0 || (DIALOG_SHOW==1&&multiFlag)) || okOnly || alwaysAsk){
		var doc=document;
		var div=doc.getById(id);
		/*if(!div){
			div=doc.createElement("div");
			div.className="dialog";
			div.id=id;
			doc.body.appendChild(div);
			disp(div,false);
		}*/
		var flag=div.style.display=="none"||(div.firstChild&&div.firstChild.className!="default_dialog");
		if(!!originalHTML){
			var dammy=doc.createElement("div");
			dammy.innerHTML=originalHTML;
			flag=flag&&dammy.innerHTML!=div.innerHTML;
		}
		if(flag||alwaysAsk){
			function dialogClose(){
				var sty=div.style;
				if(DIALOG_LEFT<0)
					sty.left=((doc.body.clientWidth||window.innerWidth)/2-div.offsetWidth/2)+"px";
				sty.top="0px";
				var ifrs=div.getElementsByTagName("IFRAME");
				for(var i=0,n=ifrs.length;i<n;i++)
					ifrs[i].parentNode.removeChild(ifrs[i]);
				disp(div,false);
			}
			function dialogDel(){
				div.innerHTML='';
			}
			function moveObj(){
				var sty=div.style;
				if(!_x){
					var y=sty.top.match(/\d+/)-0;
					var ty=(doc.body.scrollTop||doc.documentElement.scrollTop)+(doc.body.clientHeight||window.innerHeight)/2-div.offsetHeight/2;
					if(DIALOG_LEFT<0)
						sty.left=((doc.body.clientWidth||window.innerWidth)/2-div.offsetWidth/2)+"px";
					sty.top=(Math.abs(ty-y)<10?y:y+(ty-y)/3)+"px";
					if(sty.display!="none")
						setTimeout(moveObj,20);
				}
				else{
					sty.left=_x;
					sty.top=_y;
				}
			}
			div.innerHTML=originalHTML||(
				"<div class='default_dialog'><h2>■"+title+"</h2>"+
				"<p>"+str+"</p>"+
				"<form><input type='button' value='OK'>"+
				(okOnly?'':" <input type='button' value='Cancel'>")+
				"</form></div>");
			if(typeof func!="function"){
				func=function(){};
			}
			var buttons=(!!originalHTML?
				div.getElementsByTagName("button"):div.firstChild.lastChild.elements);
			if(buttons){
				if(buttons[0]){
					buttons[0].onclick=function(){ dialogClose();func(true);dialogDel() };
				}
				if(!okOnly&&buttons[1]){
					buttons[1].onclick=function(){ dialogClose();func(false);dialogDel() };
				}
			}
			var top=(doc.body.scrollTop||doc.documentElement.scrollTop)+(doc.body.clientHeight||window.innerHeight)/2-div.offsetHeight/2;
			div.style.top=(top-200)+"px";
			disp(div,true);
			moveObj();
		}
	}
	else{
		func(true);
	}
	return !flag;
}

//パスからキャッシュリストを得る
function getListByPath(path){
	path=(path=="キャッシュフォルダ"?['']:path.split('/'));
	var folderChild=pathList;
	for(var i=0,n=path.length;i<n;i++){
		folderChild=folderChild[path[i]];
	}
	return folderChild;
}

//拡張子とidが異なる場合正しい動画idを返す
function getRightId(id){
	var ext=extList[id];
	id=id.replace(/low$/,'');
	var alp=id.match(/^[a-z]+/);
	if(!ext||!alp){
		return id;
	}
	else if(ext=="swf"){
		return "nm"+id.match(/\d+$/);
	}
	else if((ext=="flv"||ext=="mp4")&&alp=="nm"){
		return "sm"+id.match(/\d+$/);
	}
	return id;
}

/*-----------------------------------------------------------------------------
HTML操作用関数群
-----------------------------------------------------------------------------*/
//formの内容を元にクエリを作成
function makeQuery(form,forSend){
	var obj=form.elements,q={};
	for(var i=0,n=obj.length;i<n;i++){
		var ele=obj[i];
		switch(ele.tagName.toLowerCase()){
			case "input":
				switch(ele.type.toLowerCase()){
					case "checkbox":
					case "radio":
						//alert([ele.name,ele.checked,ele.value]);
						if(ele.checked)q[ele.name]=ele.value;
						break;
					case "hidden":
					case "text":
						q[ele.name]=ele.value;
						break;
				}
			break;
			case "select":
				q[ele.name]=ele.options[ele.selectedIndex].value;
				break;
		}
	}
	if(forSend){
		var tmp=[],cnt=0;
		for(var i in q)
			if(typeof q[i]=="string"&&q[i].length>0)
				tmp[cnt++]=i+'='+encodeURIComponent(q[i]);
		q=form.action+'?'+tmp.join('&');
	}
	return q;
}

//strの内容を元にクエリ用Objectを復元
function parseQuery(str){
	var q={};
	var arr=str.replace(/^[^?]*\?/,'').split('&');
	for(var i=0,n=arr.length;i<n;i++){
		var obj=arr[i].split('=');
		if(typeof obj[0]=="string"&&obj[0].length>0)
				q[obj[0]]=decodeURIComponent(obj[1]);
	}
	//alert(q.toSource());
	return q;
}

//titleのtext配置を変更
function titleLayoutCh(option){
	var obj=document.getByClass("title");
	for(var i=0,n=obj.length;i<n;i++)
	{
		obj[i].style.textAlign = option;
	}
}
//表示・非表示
function disp(ele,flag){
	//後からHTML生成する
	function createFLVList(table,list){
		var folderName=table.summary;
		var folderChild=getListByPath(folderName)[''];
		var tableCnt=(table.parentNode.getElementsByTagName('A')[0].onclick+'').match(/\d+/)-0;
		if(folderChild.length==0)return '';
		var tmp=[],tmpCnt=0;
		tmp[tmpCnt++]=TEMP_TH;
		for(var cnt=0,m=folderChild.length;cnt<m;cnt++){
			var k=folderChild[cnt][0];
			var d=new Date();
			d.setTime(folderChild[cnt][4]*1000);
			tmp[tmpCnt++]=TEMP_TABLE.ins(
				{
					className	:	(/low$/.test(k)?"lowMovie":(cnt%2==0?'odd':'even')),//lowモードのflvか,奇数番目か
					href		:	k.replace("low", ''),
					dispHref	:	k,
					rightHref	:	getRightId(k),
					folder		:	folderName,
					tableCnt	:	tableCnt,
					title		:	(folderChild[cnt][1]!='' ? folderChild[cnt][1] : "(<a href='/cache/title?"+k+"'>タイトルを取得</a>)"),
					length		:	numViewCh(folderChild[cnt][3]),
					time		:	(
										[(d.getFullYear()+'').slice(-2),d.getMonth()+1,d.getDate()].join('/')+
										' '+[d.getHours(),d.getMinutes()].join(':')
									).replace(/\d+/g,function(num){ return ('0'+num).slice(-2) }),//数字を2桁にそろえる
					fileType	:	EXT_ICON_USE?' '+extList[k]:'',
					tag			:	getTagHTML(k.replace("low", ''))
				}
			);
		}
		return tmp.join('');
	}
	//以下、処理
	if(ele){
		var sty=ele.style;
		var dis=(sty.display!="none");
		if(typeof flag!="boolean"){
			flag=!dis;
		}
		//設定しようとしている状態にもうなっている場合は設定しない
		if(!sty.display||flag!=dis){
			sty.display=(flag?'':"none");
			if(flag&&ele.className.indexOf("hiddenList")!=-1){
				var tbody=ele.lastChild;
				var source=createFLVList(ele,pathList)+tbody.innerHTML;
				try{
					tbody.innerHTML=source;
				}
				catch(err){
					//IEはテーブルのinnerHTMLが直接使えないので遠回りする
					var div=document.createElement("DIV");
					div.innerHTML="<table class='flvList'><tbody>"+source+"</tbody></table>";
					ele.replaceChild(div.firstChild.firstChild,ele.lastChild);
				}
				ele.className=ele.className.replace(/\s?hiddenList/,'');
				window.ts_makeSortable(ele);
			}
		}
		return !flag;//表示切替用に反転フラグを返す
	}
	else return ele;
}

//eleのoffsetTopを指定idまでたどって求める
function getOffsetY(ele,id){
	var Y=0;
	while(ele&&ele.id!=id){
		Y+=ele.offsetTop;
		ele=ele.offsetParent;
	}
	return Y;
}
//n番目のテーブルを（非）表示
function viewTable(n){
	var obj=document.getByClass("menuLabel","LI")[n].lastChild;
	var flag=( obj&&!!obj.tagName&&obj.tagName.indexOf("UL")!=-1 ? !disp(obj) : null );
	//Operaで表示切替が画面に反映されない対策
	if(window.opera){
			window.scrollBy(0,1);
			window.scrollBy(0,-1);
	}
	var sty=document.getByClass("flvList","TABLE")[n];
	if(sty.parentNode.tagName=="DIV")disp(sty.previousSibling,flag);
	flag=disp(sty,flag);
	if(!flag){
		var folderName=document.getByClass("label")[n];
		document.getById("mainBox").scrollTop=getOffsetY(folderName,"mainBox");
	}
	autoSave();//onunload非対応判別を放棄,全ブラウザで即時保存
}
//tableの特定の列の（非）表示
function viewCol(name,flag,idx){
	var obj=document.getByClass(name);
	for(var i=0,n=obj.length;i<n;i++)
		disp(obj[i],flag);
	if(obj.length>0&&!isNaN(idx)){
		var th=document.getByClass("tableHeader");
		for(var i=0,n=th.length;i<n;i++)
			if(th[i].cells.length>idx)
				disp(th[i].cells[idx],flag);
	}
}

//オプションの（非）表示
function dispOption(sw){
	var obj=document.getById("option");
	disp(obj,sw);
	if(!sw)
		disp(document.getById("optionField"),false);
	return false;
}

// [nl] オプションに基づいたCSSとopenedListの生成
function prepareOptions(setting)
{
	var q = parseQuery(setting);
	var css = ".title { text-align: " + q["title_align"] + "}";
	
	var colList=["multi","movieId","title","time","loaded"];
	for(var i=0,n=colList.length;i<n;i++){
		var targetName=colList[i];
		if (!q[targetName])
			css += "." + targetName + " { display: none; }";
	}
	if (typeof raw == "boolean" && raw == true)
		return css;
	
	css = "<style type='text/css' id='initcss'>" + css + "</style>";

	var ol = new Array();
	if (!!q['openedList'])
	{
		var arr = q['openedList'].split('!');
		for (var i in arr)
			ol[arr[i]] = true;
	}
	
	//ソート状態の設定
	if(!!q["sort_status"]){
		SORT_FLAG=[
			{movieId:0,title:1,folder:2,size:3,time:4}[q["sort_status"].split('_')[0]],
			{down:0,up:1}[q["sort_status"].split('_')[1]]
			];
	}
	//ソート順序に関するオプション
	if(!!q["sort_rank"]&&/(\d(,|$)){4}/.test(q["sort_rank"])){
		SORT_RANK=q["sort_rank"].split(',');
	}
	else{
		SORT_RANK=[0,1,2,3];
	}
	if(!!q["sort_char"]){
		SORT_CHAR=q["sort_char"];
	}
	KANA_FIX=!!q["kana_fix"];

	//ダイアログを表示する設定
	if(!!q["dialog_show"]){
		DIALOG_SHOW={always:0,multi:1,never:2}[q["dialog_show"]];
	}
	//アイコン表示・非表示の設定にあわせて初期化する（ロード時に1度だけ実行）
	if(!!q["img_use"]){
		IMG_USE_FLAG=true;
	}
	//拡張子ごとのアイコン表示
	if(!!q["ext_icon_use"]){
		EXT_ICON_USE=true;
	}
	///外部貼り付け用サムネイルを利用する
	USE_EX_THUM=q["use_ex_thum"]||0;
	//自前の外部プレイヤー（player.html）を利用する
	USE_EX2_THUM=!!q["use_ex2_thum"];
	
	
	var IMG_TEMP=(IMG_USE_FLAG?
		"<img src='/local/{imgName}' alt='{alt}' title='{title}'>":
		"<span title='{title}' class='{className}'>{alt}</span>"
	);
	_IMG_DEL=IMG_TEMP.ins({ imgName:IMG_DEL[0],alt:IMG_DEL[1],title:IMG_DEL[2],className:"bt_del" });
	_IMG_SAVE=IMG_TEMP.ins({ imgName:IMG_SAVE[0],alt:IMG_SAVE[1],title:IMG_SAVE[2],className:"bt_save" });
	_IMG_MOVE=IMG_TEMP.ins({ imgName:IMG_MOVE[0],alt:IMG_MOVE[1],title:IMG_MOVE[2],className:"bt_move" });
	_IMG_MP3=IMG_TEMP.ins({ imgName:IMG_MP3[0],alt:IMG_MP3[1],title:IMG_MP3[2],className:"bt_mp3" });
	TEMP_TABLE=TEMP_TABLE.ins({
		IMG_DEL	:_IMG_DEL,
		IMG_SAVE:_IMG_SAVE,
		IMG_MOVE:_IMG_MOVE,
		IMG_MP3	:_IMG_MP3
	});
	TEMP_SEARCH_TABLE=TEMP_SEARCH_TABLE.ins({
		IMG_DEL	:_IMG_DEL,
		IMG_SAVE:_IMG_SAVE,
		IMG_MOVE:_IMG_MOVE,
		IMG_MP3	:_IMG_MP3
	});
	if(IMG_USE_FLAG&&document.all){
		//暫定的にIE系ブラウザの場合はプレロード
		(new Image).src="/local/"+IMG_DEL[0];
		(new Image).src="/local/"+IMG_SAVE[0];
		(new Image).src="/local/"+IMG_MOVE[0];
		(new Image).src="/local/"+IMG_MP3[0];
	}
	
	// むりやり！
	return new Array(css, ol);
}

// [nl] オプションに基づいたOptionページの設定
function setOptionPage(setting)
{
	var q = parseQuery(setting);
	var ele=document.getById("optionForm");
	if(!ele)return false;
	ele=ele.elements;
	ele["title_align"].selectedIndex={left:0,center:1,right:2}[q["title_align"]];
	if(!!q["title_edit"]){
		TITLE_EDIT={none:0,click:1,dblclick:2}[q["title_edit"]];
		ele["title_edit"].selectedIndex=TITLE_EDIT;
	}
	if(!!q["sort_status"]){
		SORT_FLAG=[
			{movieId:0,title:1,folder:2,size:3,time:4}[q["sort_status"].split('_')[0]],
			{down:0,up:1}[q["sort_status"].split('_')[1]]
			];
		ele["sort_status"].selectedIndex=SORT_FLAG[0]*2+SORT_FLAG[1];
	}
	if(!!q["sort_rank"]&&/(\d(,|$)){4}/.test(q["sort_rank"])){
		ele["sort_rank"].value=q["sort_rank"];
	}
	else{
		ele["sort_rank"].value=[0,1,2,3];
	}
	if(!!q["sort_char"]){
		ele["sort_char"].value=q["sort_char"];
	}
	ele["kana_fix"].checked=!!q["kana_fix"];
	
	if(!!q["dialog_show"]){
		DIALOG_SHOW={always:0,multi:1,never:2}[q["dialog_show"]];
		ele["dialog_show"].selectedIndex=DIALOG_SHOW;
	}
	var colList=["multi","movieId","title","time","loaded"];
	for(var i=0,n=colList.length;i<n;i++){
		var targetName=colList[i];
		ele[targetName].checked=!!q[targetName];
	}
	ele["autosave"].checked=AUTO_SAVE;
	ele["img_use"].checked=IMG_USE_FLAG;
	ele["ext_icon_use"].checked=EXT_ICON_USE;
	ele["use_ex_thum"][USE_EX_THUM].checked=true;
	if(!!q["skip_when_del"]){
		ele["skip_when_del"].checked=true;
	}
	return dispOption(false);
}
//オプションの更新
function refreshOption(form, defaultOn)
{
	var start = new Date;
	var ele=document.getById("optionForm").elements;
	var q = makeQuery(form);

	// まずはcssを消す
	var cssobj = document.getElementById('initcss');
	if (cssobj)
		cssobj.parentNode.removeChild(cssobj);
	
	//タイトルの配置
	titleLayoutCh(q["title_align"]);
	TITLE_EDIT={none:0,click:1,dblclick:2}[q["title_edit"]];
	
	//表示する行の変更
	var colList = ["multi","movieId","title","time","loaded"];
	
	for(var ix=0,n=colList.length;ix<n;ix++){
		var targetName=colList[ix];
		var flag = !!q[targetName] ? "" : "none";
		var idx = ix;
		var obj=document.getByClass(targetName, ["td", "th"]);
		for(var i=0,n=obj.length;i<n;i++)
			obj[i].style.display = flag;
	}
	
	//デフォルトのソート状態
	SORT_FLAG=[
		{movieId:0,title:1,folder:2,size:3,time:4}[q["sort_status"].split('_')[0]],
		{down:0,up:1}[q["sort_status"].split('_')[1]],
		];
	
	//ソート順序に関するオプション
	if(q["sort_rank"].split('.').length==4){
		SORT_RANK=q["sort_rank"].split('.');
	}
	else{
		SORT_RANK=[0,1,2,3];
	}
	SORT_CHAR=q["sort_char"];
	KANA_FIX=!!q["kana_fix"];
	
	//ダイアログを表示する設定
	DIALOG_SHOW={always:0,multi:1,never:2}[q["dialog_show"]];
	
	//オートセーブのOn/Off
	AUTO_SAVE=!!q["autosave"];

	//サムネイル
	USE_EX_THUM=q["use_ex_thum"]||0;

	//document.getElementById("timeresult").innerHTML = "refopt: " + (new Date - start) + "msec";

	//cookieを保存
	makeOption(form,true);
	
	//オプションを非表示に
	return dispOption(false);
}


//デフォルト設定用の文字列を生成・表示
function makeOption(form,saveToCookie,returnOptionString){
	var tmp=makeQuery(form,true).replace(/^[^?]*\?/,'');
	var table=document.getElementsByTagName("table");
	var openedList=[];
	for(var i=0,n=table.length,cnt=0;i<n;i++)
		if(table[i].style.display!="none"&&table[i].summary.length>0)
			openedList[cnt++]=table[i].summary;
	openedList=(openedList.length>0?
					"openedList="+encodeURIComponent(openedList.join('!')):''
				);
	tmp+=(openedList!=''?'&'+openedList:'');
	if(returnOptionString){
		return tmp;
	}
	else if(saveToCookie&&COOKIE_OK){
		setCookie(tmp);
	}
	else{
		var field=document.getById("optionField");
		disp(field,true);
		field.elements[0].value='var option="'+tmp+'";';
	}
	return false;
}

//cookieに保存
function setCookie(str){
	document.cookie="q="+str+"; path=/cache; expires="+new Date(2030,0,1).toGMTString();
}

//cookieを削除
function delCookie(){
	document.cookie="q=0; path=/cache; expires="+new Date(2000,0,1).toGMTString();
	return false;
}

//cookieから取得
function getCookie(){
	var tmp=document.cookie, reg=/q=[^;]+/;
	if(reg.test(tmp))
		return (tmp.match(reg)+'').slice(2);
}

//ページを閉じるときや移動するときにcookieに状態を自動で保存する
function autoSave(){
	if(AUTO_SAVE){
		makeOption(document.getById("optionForm"),true);
	}
}

//Cookieから動画番号メモのHTMLを生成
function getMemo(){
	if(COOKIE_OK){
		return	"<form onsubmit='return false'>"+
				"<p>"+
				"動画番号メモ：<input type='text' size='9'><input type='button' value='追加' onclick='setMemo(this.form.elements[0].value)'>"+
				"/<input type='button' value='全メモ消去' onclick='delMemo(0,true)'></p>"+
				"<ul>"+
					(function(){
						var tmp=document.cookie,reg=/m=([^;]+)/;
						if(reg.test(tmp)){
							var arr=RegExp.$1.split('&');
							for(var i=0,n=arr.length;i<n;i++){
								var id=arr[i].match(/[a-z]{2}\d+/);
								if(id)
									arr[i]="<li style='clear:both'><span onclick='delMemo("+id+")' class='command'>"+_IMG_DEL+"</span>"+
									"<a href='../watch/"+id+"'>"+id+"</a></li>";
							}
							return arr.join('');
						}
						else{
							return "<li>現在、メモはありません</li>";
						}
					})()
				+"</ul></form>";
	}
	else
		return "<ul><li>Cookieが無効なので使えません</li></ul>"
}

//Memoの表示
function viewMemo(sw){
	var obj=document.getById("memo");
	if(sw||!disp(obj)){
		obj.innerHTML=getMemo();
	}
}

//Memoの登録
function setMemo(movieId){
	if(COOKIE_OK){
		var tmp=document.cookie,reg=/m=([^;]+)/;
		if((reg.test(tmp)&&RegExp.$1.indexOf(movieId)==-1)||!reg.test(tmp)){
			document.cookie="m="+RegExp.$1.split('&').concat(movieId).join('&')+
				"; path=/cache; expires="+new Date(2030,0,1).toGMTString();
			document.getById("memo").innerHTML=getMemo();
		}
	}
}

//Memoの削除
function delMemo(movieId,All){
	if(COOKIE_OK){
		if(All){
			document.cookie="m=0; path=/cache; expires="+new Date(2000,0,1).toGMTString();
		}
		else{
			var tmp=document.cookie,reg=/m=([^;]+)/;
			if(reg.test(tmp)&&tmp.indexOf(movieId)!=-1){
				var arr=RegExp.$1.split('&');
				tmp=[];
				for(var i=0,n=arr.length,cnt=0;i<n;i++)
					if(arr[i].indexOf(movieId)==-1)
						tmp[cnt++]=arr[i];
				document.cookie="m="+tmp.join('&')+"; path=/cache; expires="+new Date(2030,0,1).toGMTString();
			}
			document.getById("memo").innerHTML=getMemo();
		}
	}
}

//検索ボックスの表示
function viewSearch(textValue){
	var ele=document.getById("search");
	if(!disp(ele,!!textValue||undefined)){//検索文字列がある時はタグ検索なので強制表示・それ以外はトグル
		ele.innerHTML=
			"<form onsubmit='doSearch(this.elements[0].value,this.elements[2].checked,this.elements[3].checked,this.parentNode.lastChild);return false'>"+
			"<input type='text'"+(!textValue?'':"value='"+textValue+"'")+"><input type='button' value='検索' onclick='this.form.onsubmit()'>"+
			"<label for='regmode'><input type='checkbox' id='regmode'>正規表現(/入力内容/ig)として解釈</label>"+
			"<label for='tagmode'><input type='checkbox' id='tagmode'"+(!textValue?'':" checked")+">タグを検索</label>"+//タグ検索時は自動でON
			"</form><div style='display:none'></div>";
		if(!!textValue)ele.firstChild.onsubmit();
		ele.firstChild.firstChild.focus();
	}
}

//検索結果の表示
function doSearch(target,regFlag,tagFlag,ele){
	try{
		if(!target||target==''){
			var cnt=0;
		}
		else{
			if(regFlag){
				try{
					target=new RegExp(target,'ig');
				}catch(e){
					Dialog({
						title:"エラー",
						str:"<p style='width:480px;text-align:left'>不正な正規表現です。<br>ヒント：正規表現内で\\を表すには\\\\、?などのメタ文字自体を表すときには\\?のように記述してください。</p>",
						okOnly:true,
						alwaysAsk:true
					});
					return;
				}
			}
			
			var table=document.getElementsByTagName("table");
			var openedList=[];
			for(var i=0,n=table.length,cnt=0;i<n;i++)
				if(table[i].style.display!="none"&&table[i].summary.length>0)
					openedList[table[i].summary]="opened";
			
			var flvList=toArray(cacheList);
			var tmp=[];
			for(var i=0,n=flvList.length,cnt=0;i<n;i++){
				var movieId=flvList[i][0].replace("low", '');
				var movieTitle=flvList[i][1];
				var movieTag=tagList[movieId];
				
				if(
					(tagFlag&&!!movieTag&&(//タグ検索の場合
							(!regFlag&&movieTag.indexOf(target)!=-1)||
							(regFlag&&target.test(movieTag))
						)
					)||
					(!tagFlag&&!!movieTitle&&(//タイトル検索の場合
							(!regFlag&&movieTitle.indexOf(target)!=-1)||
							(regFlag&&target.test(movieTitle))
						)
					)
				){
					var d=new Date();
					d.setTime(flvList[i][4]*1000);
					tmp[cnt++]=TEMP_SEARCH_TABLE.ins({
								className	:	(openedList[flvList[i][2]||"キャッシュフォルダ"]?"opened":
													(flvList[i][0].indexOf("low")!=-1?"lowMovie":
														(cnt%2==1?"odd":"even")
													)
												),
								href		:	movieId,
								folder		:	flvList[i][2]||"キャッシュフォルダ",
								dispHref	:	flvList[i][0],
								rightHref	:	getRightId(movieId),
								tableCnt	:	0,
								title		:	movieTitle,
								length		:	numViewCh(flvList[i][3]),
								time		:	(
													[(d.getFullYear()+'').slice(-2),d.getMonth()+1,d.getDate()].join('/')+
													' '+[d.getHours(),d.getMinutes()].join(':')
												).replace(/\d+/g,function(num){ return ('0'+num).slice(-2) }),//数字を2桁にそろえる
								fileType	:	EXT_ICON_USE?' '+extList[flvList[i][0]]:'',
								tag			:	getTagHTML(movieId.replace("low",''))
							});
				}
			}
		}
		if(cnt==0){
			tmp=["<tr><td>ヒットなし</td></tr>"];
		}
		else{
			tmp=[TEMP_SEARCH_TH].concat(tmp);
		}
		ele.innerHTML="<table class='label'><tr><td>"+(cnt>0?"<a href='javascript:void(0)' onclick='disp(document.getById(\"search_res\"))'>":'')+"検索結果"+(cnt>0?"</a></td><td class='files'>("+fileCount(cnt)+')':'')+"</td></tr></table><div id='search_res'><table class='sortable'>"+tmp.join('')+"</table></div>";
		if(cnt>0)
			window.ts_makeSortable(ele.lastChild.lastChild);
		disp(ele,true);
		ele.lastChild.style.height=Math.min(RESULT_MAX_HEIGHT,ele.lastChild.lastChild.offsetHeight)+"px";
	}catch(err){
		Dialog({
			title:"エラー",
			str:err.toString()
		});
	}
}

//サムネイルの表示(thumType={Number}:指定した形式のサムネイルを表示)
function viewThum(ele,thumType){
	//指定したウェイトを超えていれば表示(元thumType+10でコール時)
	if(thumType>=10){
		clearTimeout(THUM_WAIT_TIMER);
		return THUM_WAIT_TIMER=setTimeout((function(ele,thumType){
			return function(){viewThum(ele,thumType-10)};
		})(ele,thumType),THUM_WAIT);
	}
	if(!ele.tagName){
		try{
			ele=document.getElementsByClassNameAndTagName
				("movieId", document.getElementById(ele), "TD")[0];
			if(ele.lastChild.href){
				ele=ele.lastChild;
			}
		}catch(e){
			return;
		}
	}
	if(!ele){
		return;
	}
	ele.firstChild.data.match(/([a-z]{2}\d+(low)?)/);
	var movieId=RegExp.$1;
	var tmp;
	thumType=thumType||USE_EX_THUM;
	if(thumType==0){
		tmp=
			"<div class='loading'>loading..."+
			"<img src='/local/"+IMG_THUM_LOADING+"'></div>"+
			"<img src='http://tn-skr.smilevideo.jp/smile?i="+movieId.replace(/low$/,'').slice(2)+
			"' onload='disp(this.previousSibling);this.style.width=\"\"'"+
			" onerror='this.src=\"/img/thumb/del_img.jpg\"' style='width:0px'"+
			" title='"+movieId+"'>";
	}
	else if(thumType==1){
		//外部貼り付け用サムネイル
		tmp=
			"<div class='loading'>loading..."+
			"<img src='/local/"+IMG_THUM_LOADING+"'></div>"+
			"<iframe class='thum_root' src='/thumb/"+movieId.replace(/low$/,'')+
			"' onload='disp(this.previousSibling);disp(this)'"+
			"' frameborder='0' style='display:none'"+
			" title='"+movieId+"'></iframe>";
	}
	else if(thumType==2){
		//自前のプレイヤーによる簡易再生
		ele.onmouseout=null;
		var IMG_TEMP=(IMG_USE_FLAG?
		"<img src='/local/{imgName}' alt='{alt}' title='{title}'>":"{alt}");
		var _IMG_DEL2=IMG_TEMP.ins({ imgName:IMG_DEL[0],alt:IMG_DEL[1],title:IMG_DEL[2]});
		var _IMG_SAVE2=IMG_TEMP.ins({ imgName:IMG_SAVE[0],alt:IMG_SAVE[1],title:IMG_SAVE[2]});
		var _IMG_MOVE2=IMG_TEMP.ins({ imgName:IMG_MOVE[0],alt:IMG_MOVE[1],title:IMG_MOVE[2]});
		var _IMG_MP32=IMG_TEMP.ins({ imgName:IMG_MP3[0],alt:IMG_MP3[1],title:IMG_MP3[2]});
		var info=cacheList[movieId]||tempList[movieId]||null;
		if(!info){
			return;
		}
		tmp=	("<h3 class='moviePlayer'><span><button>×</button>"+
				"<button onclick=\"location.href='./{dispHref}/movie'\">{IMG_SAVE}</button>"+
				"<button onclick=\"location.href='./{dispHref}/audio'\">{IMG_MP3}</button>"+
				"<button onclick=\"delFLV(0,'{dispHref}');if(DIALOG_SHOW>0)this.parentNode.firstChild.onclick()\">{IMG_DEL}</button>"+
				"<button onclick=\"viewMoveOption('{dispHref}','{folder}')\">{IMG_MOVE}</button>"+
				"</span><span><a href=\"/watch/{rightHref}\" onclick=\"this.parentNode.parentNode.getElementsByTagName('button')[0].onclick();if(ORIG_PLAYER_LINK_NWIN&&window.open(this.href)){return false}\"{target}>{dispHref}</a> － {title}</span></h3>"+
				"<iframe src='/local/resource/player/player.html?src="+movieId+"/movie"+(PUSHED_SHIFT?'&autoplay':'')+"' width='512' height='420'"+
				" scrolling='no' frameborder='0'></iframe>")
			.ins({  dispHref:movieId,rightHref:getRightId(movieId),
					title:info[0],folder:info[1],
					IMG_DEL:_IMG_DEL2,IMG_SAVE:_IMG_SAVE2,IMG_MOVE:_IMG_MOVE2,IMG_MP3:_IMG_MP32,
					target:(ORIG_PLAYER_LINK_NWIN?' target="_blank"':'')});
	}
	var dChild=document.getById('dialog').childNodes;
	if( thumType<2||
		!dChild[0]||
		(dChild[0].className!="default_dialog"&&
		 dChild[0].childNodes[1].innerHTML.split(" － ")[0]!=movieId)
	  ){
		if(thumType!=2){
			function getOffset(ele){
				if(!ele)
					return {x:null,y:null};
				var x=ele.offsetLeft,
					y=ele.offsetTop,
					labelCnt=1;
				while(ele.offsetParent){
					ele=ele.offsetParent;
					if((ele.className+'').indexOf("label")!=-1)
						labelCnt+=2;
					x+=(ele.offsetLeft||0);
					y+=(ele.offsetTop||0)
						-ele.style.borderTop.match(/\d+/)-ele.style.borderBottom.match(/\d+/)
						-(ele.scrollTop||0);
				}
				return {x:x,y:y,cnt:labelCnt};
			}
			var doc=document,
				td=ele.parentNode,
				tr=td.parentNode,
				table=tr.parentNode.parentNode,
				mainbox=table.parentNode,
				x=getOffset(ele).x+ele.offsetWidth,
				y=getOffset(tr.nextSibling||tr).y+(tr.nextSibling?0:tr.offsetHeight);
			y=Math.min(y,(doc.body.clientHeight||window.innerHeight)-[100,200][thumType]);
			if(window.thumTID)
				clearTimeout(thumTID);
		}
		Dialog({
			okOnly:true,
			originalHTML:tmp,
			id:(thumType==2?null:"thum"),
			x:x,
			y:y
		});
	}
	else{
		return;
	}
}

//サムネイルの非表示
function hideThum(ele,allHide,forceHide){
	clearTimeout(THUM_WAIT_TIMER);
	if(!PUSHED_SHIFT&&(allHide&&USE_EX_THUM<2||USE_EX_THUM==0)){
		var thum=document.getElementById("thum");
		if(thum&&thum.firstChild&&thum.firstChild.className!="default_dialog"){
			disp(thum,false);
			thum.innerHTML='';
		}
	}
	else if(USE_EX_THUM==1){
		thumTID=setTimeout((function(ele){
			return function(){
				hideThum(ele,true);
			};
		})(ele),3000);
	}
}
/*-----------------------------------------------------------------------------
Ajax関連関数群
-----------------------------------------------------------------------------*/
//Ajax通信用
var lastModifiedList={};
function Ajax(url,callback,sync){
	function getAjax(){
		if(window.XMLHttpRequest)
			return new XMLHttpRequest();//Fx,Sf,IE7
		else if(window.ActiveXObject){
			var list=["Msxml2.XMLHTTP.6.0","Msxml2.XMLHTTP.3.0","Microsoft.XMLHTTP"];
			for(var i=0,n=list.length;i<n;i++){
				try{
					return new ActiveXObject(list[i]);//-IE6
				}catch(e){}
			}
		}
		return null;
	}
	//データの更新日時に変化がなければfalse
	function isChange(e,url){
		var  mod=e.getResponseHeader("Last-Modified");
		var flag=!lastModifiedList[url]||lastModifiedList[url]==mod;
		lastModifiedList[url]=mod;
		return flag;
	}
	var e=getAjax();
	if(e){
		if(typeof callback=="function"){
			e.onreadystatechange=function(){
				if(e.readyState==4){											//4->Complete
					callback(e.status==200&&isChange(e,url),e.responseText,e);	//200->成功,other->失敗
					e.onreadystatechange=function(){};							//リーク防止
				}
			};
			e.open("GET", url, !sync);//sync未指定時は非同期,sync==trueで同期通信
			e.setRequestHeader("Content-type","application/x-www-form-urlencoded; charset=UTF-8");
			e.setRequestHeader("If-Modified-Since",(new Date).toGMTString());
			e.setRequestHeader("Connection","close");
			e.send('');
			if(sync){
				return e.responseText;
			}
		}
	}
	return e;
}

//削除提案
function cacheLimit(ele){
	Ajax("/local/"+CACHE_LIMIT_RULE,function(flag,res,e){
		if(flag){
			var List=[];
			var XML=e.responseXML;
			var Rule=XML.documentElement.childNodes;
			var tmpArr=toArray(cacheList);//.childFillter(2,'');//キャッシュフォルダのみ抽出 ["smXXX","title","folder","Byte","Time"]
			var cacheSize=0;
			for(var i=0,n=tmpArr.length;i<n;i++){
				cacheSize+=tmpArr[i][3];
			}
			cacheSize=Math.ceil(cacheSize/(1024*1024));
			for(var i=0,n=Rule.length;i<n;i++){
				if(Rule[i].tagName=="rule"){
					var limit=eval(Rule[i].getAttribute("limit")||0);
					if(cacheSize>=limit){
						try{
							var exfolder=new RegExp(Rule[i].getAttribute("exfolder")||'\0','i');
							var exfile=new RegExp(Rule[i].getAttribute("exfile")||'\0','i');
							var buf=[],cnt=0
							for(var j=0,m=tmpArr.length;j<m&&cacheSize>=limit;j++){
								if(!(exfolder.test(tmpArr[j][2])||exfile.test(tmpArr[j][1]))){
									buf[cnt++]=tmpArr[j];
									cacheSize-=Math.floor(tmpArr[j][3]/(1024*1024));
									tmpArr.splice(j,1);
									j--;
									m--;
								}
							}
							List=List.concat(buf.childXSort(4,Rule[i].getAttribute("sort")!="old"));
						}catch(e){
							var exfolder=Rule[i].getAttribute("exfolder");
							var exfile=Rule[i].getAttribute("exfile");
							Dialog({
								title:"エラー",
								str:"以下のルールは不正です。<br>サイズ制限による削除提案を中止しました。<pre style='padding:5px;text-align:left'>exfolder:\t"+(exfolder||'指定なし')+"\nexfile:\t"+(exfile||'指定なし')+"</pre>"+
								"<p>ヒント：正規表現内で\\を表すには\\\\、?などのメタ文字自体を表すときには\\?のように記述してください。</p>",
								okOnly:true,
								alwaysAsk:true
							});
							return;
						}
					}
				}
			}
			var tmp=[],cnt=0;
			for(var i=0,n=List.length;i<n;i++){
				var d=new Date();
				d.setTime(List[i][4]*1000);
				var movieId=List[i][0].replace("low", '');
				tmp[cnt++]=TEMP_TABLE.replace("class='title'","class='title' title='{folderName}'").ins({
							className	:	(List[i][0].indexOf("low")!=-1?"low":
												(cnt%2==1?"odd":"even")
											),
							href		:	movieId,
							folderName	:	List[i][2]+'/',
							dispHref	:	List[i][0],
							rightHref	:	getRightId(List[i][0]),
							tableCnt	:	0,
							title		:	List[i][1],
							time		:	(
												[(d.getFullYear()+'').slice(-2),d.getMonth()+1,d.getDate()].join('/')+
												' '+[d.getHours(),d.getMinutes()].join(':')
											).replace(/\d+/g,function(num){ return ('0'+num).slice(-2) }),//数字を2桁にそろえる
							fileType	:	EXT_ICON_USE?' '+extList[List[i][0]]:'',
							tag			:	getTagHTML(movieId)
						});
			}
			if(cnt==0){
				tmp=["<tr><td>ヒットなし</td></tr>"];
			}
			else{
				tmp=[TEMP_TH].concat(tmp);
			}
			ele.innerHTML="<table class='label'><tr><td>"+(cnt>0?"<a href='javascript:void(0)' onclick='disp(document.getById(\"lim_res\"))'>":'')+"削除提案"+(cnt>0?"</a></td><td class='files'>("+fileCount(cnt)+')':'')+"</td></tr></table><div id='lim_res'><table>"+tmp.join('')+"</table></div>";
			if(cnt>0)window.ts_makeSortable(ele.lastChild.firstChild);
			ele=ele.lastChild;
			ele.lastChild.style.height=Math.min(RESULT_MAX_HEIGHT,ele.lastChild.lastChild.offsetHeight)+"px";
		}
	});
}
//フォルダの自動振り分け
function autoMove(){
	Ajax("/local/"+AUTOMOVE_RULE,function(flag,res,e){
		if(flag){
			var List={};
			var XML=e.responseXML;
			var Rule=XML.documentElement.childNodes;
			var tmpArr=toArray(cacheList).childFillter(2,'');//キャッシュフォルダのみ抽出 ["smXXX","title","folder","Byte","Time"]
			for(var i=0,n=Rule.length;i<n;i++){
				if(Rule[i].tagName=="rule"){
					var path=Rule[i].getAttribute("path");
					try{
						var reg=new RegExp(Rule[i].getAttribute("reg"),Rule[i].getAttribute("flag")||'');
						for(var j=0,m=tmpArr.length;j<m;j++){
							if(reg.test(tmpArr[j][1])){
								if(!List[path]){
									List[path]=[];
								}
								List[path].push([path,tmpArr[j][0],tmpArr[j][1]]);
								tmpArr.splice(j,1);
								j--;
								m--;
							}
						}
					}catch(e){
						var reg=Rule[i].getAttribute("reg");
						var flag=Rule[i].getAttribute("flag");
						Dialog({
							title:"エラー",
							str:"以下のルールは不正です。<br>自動振り分けを中止しました。<pre style='padding:5px;text-align:left'>path:\t"+(path||'指定なし')+"\nreg:\t"+(reg||'指定なし')+"\nflag:\t"+(flag||'指定なし')+"</pre>"+
							"<p>ヒント：正規表現内で\\を表すには\\\\、?などのメタ文字自体を表すときには\\?のように記述してください。</p>",
							okOnly:true,
							alwaysAsk:true
						});
						return;
					}
				}
			}
			var tmp=[],idx=0,cnt=0;
			for(var path in List){
				tmp[idx++]=path+" へ移動：";
				for(var i=0,n=List[path].length;i<n;i++){
					tmp[idx++]='　　'+List[path][i][1]+'｜'+List[path][i][2];
					cnt++;
				}
			}
			if(cnt>0){
				Dialog({
					title:"自動振り分けによる移動",
					str:"以下の動画("+fileCount(cnt)+")を移動しますか？<div>"+tmp.join("<br>")+"</div>",
					func:function(flag){
						if(flag){
							for(var path in List){
								for(var i=0,n=List[path].length;i<n;i++)
									moveFLV(List[path][i][1],'',List[path][i][0]);
							}
						}
					},
					multiFlag:true,
					alwaysAsk:true
				});
			}
			else{
				Dialog({
					title:"自動振り分けによる移動",
					str:"該当する動画はありませんでした",
					alwaysAsk:true
				});
			}
			//alert(List.toSource().replace(/\\u(\w{4})/ig,function(all,code){return String.fromCharCode(parseInt(code,16))}));
		}
	});
}

//ダブっているファイルを表示
function sameFile(ele){
	//*重複（同じFLV or 通常モードと低画質モードのFLV)したファイルを列挙する
	var dup=["<li>低高画質重複キャッシュ一覧（クリックで消去）</li>"],cnt=0;
	var arr=cacheList;
	for(var i in arr){
		if(!!arr[i+'low'])
			dup[cnt++]="<li><img src='/local/del.png' onclick='delFLV(0,this,\""+i+"low\")'>"+i+"low["+(arr[i][0]||arr[i+'low'][0])+"]</li>";
	}
	if(cnt==0)
		dup=["<li>低高画質が重複しているキャッシュはありません</li>"];
	ele.innerHTML="<ul>"+dup.join('')+"</ul>";
	//*サイズが同じファイルを列挙する
	try{
		var table=document.getElementsByTagName("table");
		var openedList=[];
		for(var i=0,n=table.length,cnt=0;i<n;i++)
			if(table[i].style.display!="none"&&table[i].summary.length>0)
				openedList[table[i].summary]="opened";
		var arr=cacheList;
		var checkArray={};//ファイルサイズをインデックスとする連想配列
		for(var i in arr){
			//i=ID
			if(arr[i]){
				var size=arr[i][2];
				(!checkArray[size])?checkArray[size]=[i]:checkArray[size].push(i);
			}
		}
		var tmp=[],cnt=0;
		for(var i in checkArray){
			//i=ファイルサイズ
			if(checkArray[i].length > 1&&!isNaN(i)){
				tmp[cnt++]="<tr><td colspan=6 class='samesize'>"+numViewCh(i)+"</td></tr>"
				for(var j=0;j<checkArray[i].length;j++){
					var id = checkArray[i][j]+"";
					var d=new Date();
					d.setTime(arr[id][3]*1000);
					tmp[cnt++]=TEMP_SEARCH_TABLE.ins({
						className	:	(openedList[arr[id][1]||"キャッシュフォルダ"]?"opened":
							(arr[id][0].indexOf("low")!=-1?"lowMovie":
								(cnt%2==1?"odd":"even")
							)
						),
						href		:	id.replace("low", ''),
						folder		:	arr[id][1]||"キャッシュフォルダ",
						dispHref	:	id,
						rightHref	:	getRightId(id),
						tableCnt	:	0,
						title		:	arr[id][0],
						length		:	numViewCh(arr[id][2],0),
						time		:	(
								[(d.getFullYear()+'').slice(-2),d.getMonth()+1,d.getDate()].join('/')+
								' '+[d.getHours(),d.getMinutes()].join(':')
						).replace(/\d+/g,function(num){ return ('0'+num).slice(-2) }),//数字を2桁にそろえる
						fileType	:	EXT_ICON_USE?' '+extList[id]:'',
						tag			:	getTagHTML(id.replace("low", ''))
					});
				}
			}
		}
		tmp=(cnt==0)?["<tr><td>ヒットなし</td></tr>"]:tmp=[TEMP_SEARCH_TH].concat(tmp);
		ele.innerHTML+="<table class='label'><tr><td>"+(cnt>0?"<a href='javascript:void(0)' onclick='disp(document.getById(\"same_size_res\"))'>":'')+"同サイズ検索結果"+(cnt>0?"</a></td><td class='files'>("+fileCount(cnt)+')':'')+"</td></tr></table><div id='same_size_res'><table class='sortable'>"+tmp.join('')+"</table></div>";
		if(cnt>0)
			window.ts_makeSortable(ele.lastChild.lastChild);
		disp(ele,true);
		ele.lastChild.style.height=Math.min(RESULT_MAX_HEIGHT,ele.lastChild.lastChild.offsetHeight)+"px";
	}catch(err){
		Dialog({
			title:"エラー",
			str:err.toString()
		});
	}
}
/*
 * 簡易表示版
function sameFile(ele){
	var dup=["<li>同一サイズキャッシュ一覧（クリックで消去）</li>"],cnt=0;
	var arr=cacheList;
	var checkArray=new Array();//ファイルサイズをインデックスとする配列
	for(var i in arr){
		//i=ID
		var size=arr[i][2];
		if(!checkArray[size]){
			checkArray[size]=new Array();
			checkArray[size][0]=i;
		}else{
			checkArray[size].push(i);
		}
	}
	for(var i in checkArray){
		//i=ファイルサイズ
		if(checkArray[i].length > 1&&!isNaN(i)){
			dup[cnt++]="<li>"+numViewCh(i)+"</li>"
			for(var j=0;j<checkArray[i].length;j++){
				var id = checkArray[i][j]+"";
				dup[cnt++]="<li><img src='../local/resource/img/del.gif' alt='削' onclick='delFLV(0,\""+id+"\",false,false)'>"+id+"["+arr[id][0]+"]</li>";
			}
		}
	}
	if(cnt==0)
		dup=["<li>同サイズのキャッシュはありません</li>"];
	ele.innerHTML="<ul>"+dup.join('')+"</ul>";
}
*/
//FLV削除
function delFLV(hideFlag,id,isTmp,noDialog){
	function doDel(flag){
		if(flag){
			var obj=Ajax("/cache/ajax_rm"+(isTmp?"tmp":'')+'?'+id,function(flag,res){
				if(flag&&res.indexOf("OK")!=-1){
					var e = document.getElementById(id);
					if(e){
						e.style.display = 'none';
						e.parentNode.removeChild(e);
					}
					if(isTmp){
						delete tempList[id];
					}
					else{
						//フォルダのリストから削除
						var oldList=getListByPath(cacheList[id][1])[''];
						for(var i=0,n=oldList.length;i<n;i++){
							if(oldList[i][0]==id){
								oldList.splice(i,1);
								break;
							}
						}
						cacheList[id]=null;
					}
				}
			});
		}
	}
	if(noDialog){
		doDel(true);
	}
	else{
		Dialog({
			title:"キャッシュの削除確認",
			str:"キャッシュ（"+id+"）を削除しますか？",
			func:doDel
		});
	}
}

//mod nl_1
function getTableBySummary(str)
{
	var table=document.getElementsByTagName("table");
	for(var i=1,n=table.length;i<n;i++){
		if(str == table[i].summary)
			return table[i];
	}
	return null;
}

//FLV移動
function moveFLV(id,oldFolder,newFolder){
	if(oldFolder != (newFolder||"キャッシュフォルダ")){
		var obj=Ajax("/cache/ajax_move?"+id+'-'+encodeURI(newFolder),function(flag,res){
			if(flag&&res.indexOf("OK")!=-1){
				var insOK = false;
				// 挿入先のテーブルと、移動する列
				var table = getTableBySummary(newFolder != '' ? newFolder : "キャッシュフォルダ");
				var row = document.getElementById(id);
				
				if (!!row && !!table){
					row.parentNode.removeChild(row);
					var tbody=table.lastChild;
					//旧フォルダのリストから削除
					var oldList=getListByPath(oldFolder)[''];
					for(var i=0,n=oldList.length;i<n;i++){
						if(oldList[i][0]==id){
							oldList.splice(i,1);
							break;
						}
					}
					var folderChild=getListByPath(table.summary);
					if(table.className.indexOf("hiddenList")==-1){
						//ヘッダがない場合は付加
						if(folderChild[''].length==0){
							try{
								tbody.innerHTML=TEMP_TH;
							}
							catch(err){
								//IEはテーブルのinnerHTMLが直接使えないので遠回りする
								var div=document.createElement("DIV");
								div.innerHTML="<table class='flvList'><tbody>"+TEMP_TH+"</tbody></table>";
								table.replaceChild(div.firstChild.firstChild,table.lastChild);
							}
						}
						tbody.appendChild(row);
						if(row.firstChild.className=="Multi")
							row.firstChild.firstChild.checked=false;
						ele=row.childNodes;
						for(var i=0,n=ele.length;i<n;i++){
							if(ele[i].className=="movieId"){
								ele[i].childNodes[3].ele.onclick=
									function(){ viewMoveOption(id, newFolder) };
								break;
							}
						}
					}
					insOK=true;
					cacheList[id][1]=newFolder;
					folderChild[''].push([id].concat(cacheList[id]));
				}
				if(!insOK){
					location.href=location.href;//reload
				}
			}
			else{
				viewMoveOption(id,oldFolder);
			}
		});
	}
}

//移動UI表示
function viewMoveOption(id,folderName){
	var tmp='';
	for(var i=0,n=dirList.length;i<n;i++)
		tmp+="<option value='{value}'{selected}>{name}</option>".ins({
			value		:	dirList[i],
			name		:	dirList[i]!=''?dirList[i]:"キャッシュフォルダ",
			selected	:	folderName==(dirList[i]!=''?dirList[i]:"キャッシュフォルダ")?" selected":''
		});
	Dialog({
		title:"移動確認:"+folderName+'/'+id,
		str:"<form id='moveTo' style='margin:10px'>移動先：<select>"+tmp+"</select></form>",
		func:function(flag){
			var _this=document.getById("moveTo").elements[0];
			if(flag)moveOK(_this,id,folderName);
		},
		alwaysAsk:true
	});
}

//移動先決定後の処理
function moveOK(obj,id,folder){
	var opt=obj.form.elements[0];
	moveFLV(id,folder,opt.options[opt.selectedIndex].value);
}

//タイトルを取得
function getTitle(ele){
	ele=ele.parentNode;
	ele.innerHTML="N/A";
	viewTitleBox(ele,TITLE_EDIT);
	ele.firstChild.value='';
	ele.firstChild.blur();
}
//タイトルをクリックしたときテキストボックスにする
function viewTitleBox(ele,type){
	if(TITLE_EDIT==type){
		var title=ele.innerHTML||'';
		ele.onclick=ele.ondblclick=function(){};
		ele.innerHTML=
			"<input type='text' value='{title}' onblur='chTitle(this,\"{title}\")' title='空欄でデフォルト' style='width:100%'>"
			.ins({ title:title.split("'").join("&#39;") });
		ele.firstChild.focus();
		ele.firstChild.select();
	}
}

//テキストボックスの内容を新しいタイトルにする
function chTitle(ele,oldTitle){
	var title=ele.value||'';
	ele=ele.parentNode;
	//タイトルで使えない文字を置換
	for(var i=0,n=TITLE_REPLACE_CHAR.length,idx; i<n; i++)
		title=title.split(TITLE_REPLACE_CHAR[i][0]).join(TITLE_REPLACE_CHAR[i][1]);
	if(title==oldTitle){
		ele.onclick=function(){ viewTitleBox(ele,1) };
		ele.ondblclick=function(){ viewTitleBox(ele,2) };
		ele.innerHTML=title;
	}
	else
		Ajax("/cache/ajax_title?"+ele.parentNode.parentNode.id+(title!=''?'-'+encodeURI(title):''),function(flag,res){
			ele.onclick=function(){ viewTitleBox(ele,1) };
			ele.ondblclick=function(){ viewTitleBox(ele,2) };
			ele.innerHTML=
				(flag&&res.indexOf("OK")!=-1?
				res.replace(/OK/,''):
				"タイトルを取得できませんでした(<a href='javascript:void(0)' onclick='getTitle(this)'>リトライ)</a>"
				);
		});
}

//複数に対するコマンド実行用リストへの追加/削除
function addMulti(id,flag){
	if(!!MULTI_LIST[id]&&!flag){
		delete MULTI_LIST[id];
	}
	if(flag){
		MULTI_LIST[id]=true;
	}
}

//複数に対するコマンド実行
function doMulti(command){
	switch(command){
		case 1://削除
			var tmp=[],cnt=0;
			for(var id in MULTI_LIST){
				var title=(cacheList[id]||tempList[id]||["N/A"])[0];
				tmp[cnt++]=id+':'+(title!=''?title:"N/A");
			}
			Dialog({
				title:"一括削除",
				str:"以下の動画("+fileCount(cnt)+")を削除しますか？<div>"+tmp.join("<br>")+"</div>",
				func:function(flag){
					if(flag){
						for(var id in MULTI_LIST){
							delFLV(0,id,!!tempList[id],true);
						}
						MULTI_LIST={};
					}
				},
				multiFlag:true
			});
			break;
		case 2://移動
			var tmp='';
			for(var i=0,n=dirList.length;i<n;i++)
				tmp+="<option value='{value}'>{name}</option>".ins({
					value		:	dirList[i],
					name		:	dirList[i]!=''?dirList[i]:"キャッシュフォルダ"
				});
			Dialog({
				title:"移動確認",
				str:"<form id='moveTo' style='margin:10px'>移動先：<select>"+tmp+"</select></form>",
				func:function(flag){
					if(flag){
						var _this=document.getById("moveTo").elements[0];
						for(var id in MULTI_LIST){
							moveOK(_this,id,(cacheList[id]||['',''])[1]);
						}
						MULTI_LIST={};
					}
				},
				multiFlag:true,
				alwaysAsk:true
			});
			break;
	}
}

//「選」ボタンでそのフォルダ内のすべてのチェックをON/OFF
function multiCheck(obj){
	var rows=obj.parentNode.parentNode.parentNode.lastChild.rows;
	var btSelect=rows[0].firstChild.firstChild;
	var flag=!btSelect.className||btSelect.className.indexOf("bt_select_off")!=-1;
	btSelect.className="bt_select_"+(flag?"on":"off");
	for(var i=1,n=rows.length;i<n;i++){
		var checkBox=rows[i].firstChild.firstChild;
		checkBox.checked=flag;
		checkBox.onclick();
	}
}
//動画リストを取得
function getDefaultList(){
	eval(Ajax("/cache/ajax",function(){},true));//var cacheList={id:ext,...};などなど
	if(!window.ncversion||!window.dirList||!window.tempList||!window.cacheList)
		document.write("<h1>Error：</h1><p>NicoCache_nlから動画情報を取得できませんでした。<br><a href='/cache/ajax'>このリンク先</a>が表示されますか？<br>また、表示された場合でもその中に欠損がある場合があります。</p>");
}


//拡張子リストを取得
function getExt(){
	eval(Ajax("/cache/extlist",function(){},true));//var extList={id:ext,...};
	if(!window.extList)
		document.write("<h1>Error：</h1><p>拡張プラグイン\"nlGetFileExt.class\"が必要です。<br>NicoCache_nl.jarのあるフォルダに同梱のextensionsフォルダをコピーしてください。</p>");
	return extList;
}

//タグリストを取得
function getTag(){
	eval(Ajax("/cache/taglist",function(){},true));//var tagList={id:tag,...}
	if(!window.tagList)
		document.write("<h1>Error：</h1><p>拡張プラグイン\"nlGetTag.class\"が必要です。<br>NicoCache_nl.jarのあるフォルダに同梱のextensionsフォルダをコピーしてください。</p>");
	return tagList;
}
//タグを表すHTMLを返す
function getTagHTML(id){
	var tag=tagList[id];
	if(!tag)return '<a href="javascript:void(0)" onclick="tagInfoView(this)">タグを追加する</a>';
	else{
		var res=[];
		tag=tag.split(' ');
		for(var i=0,n=tag.length; i<n; i++)
			res[i]='<a href="javascript:void(0)" onclick="tagInfoView(this,\''+tag[i]+'\')">'+tag[i]+'</a>';
		return res.join(' ');
	}
}
//タグに関する情報ウィンドウを表示
function tagInfoView(ele,tag){
	var tagView=ele.parentNode.lastChild;
	var jsHref="javascript:void(0)";
	var temp='<li><a href="{HREF}" onclick="return getTagInfo(this,\'{TAG}\',{TYPE})" target="_blank">"{TAG}"{MES}</a></li>';
	var res=[];
	if(!tag){
		res.push(temp.ins({HREF:jsHref,TAG:"タグ",TYPE:4,MES:"を追加(未実装)"}));
	}else{
		res.push(temp.ins({HREF:jsHref,TAG:tag,TYPE:0,MES:"を含むキャッシュを検索"}));
		res.push(temp.ins({HREF:"/tag/"+encodeURIComponent(tag),TAG:tag,TYPE:1,MES:"を含む動画をニコニコで検索(別窓)"}));
		res.push(temp.ins({HREF:jsHref,TAG:"このタグ",TYPE:2,MES:"を編集(未実装)"}));
		res.push(temp.ins({HREF:jsHref,TAG:tag,TYPE:3,MES:"を削除(未実装)"}));
	}
	tagView.innerHTML="<h3>タグ情報：</h3><ul>"+res.join('\n')+"</ul>";
	disp(tagView,true);
}
//タグに関する情報を返す
function getTagInfo(ele,tag,type){
	var tagView=ele.parentNode.parentNode.parentNode.lestChild;
	if(type==0)viewSearch(tag);
	else if(type==1)return !window.open(ele.href);
	else if(type==2||type==3||type==4)Dialog({title:"エラー",str:"nlGetTag rev02では未実装"});
	else Dialog({title:"エラー",str:"tagGetInfo(type="+type+")は未実装"});
	return false;
}
//タグクラウドを表示
function tagCloud(ele){
	function log10(x){
		return Math.LOG10E*Math.log(x);
	}
	//出現回数をカウント
	var tagCnt={};
	for(var i in tagList){
		var tagArr=tagList[i].split(' ');
		for(var j=0,n=tagArr.length; j<n; j++){
			var tag=tagArr[j];
			!tagCnt[tag]?tagCnt[tag]=[1]:tagCnt[tag][0]++;
		}
	}
	tagCnt=toArray(tagCnt);
	//出現回数でソート
	tagCnt=tagCnt.sort(function(a,b){return b[1]-a[1]});
	//フォントサイズを決めつつHTML出力
	var res=[];
	var max=tagCnt[0][1],min=tagCnt[tagCnt.length-1][1];
	var fontMax=48,fontMin=9, colorMax=0,colorMin=150;//フォント、色(0-255)の最小・最大値を設定
	var preFont=(fontMax-fontMin)/(log10(max)-log10(min));//共通部分のキャッシュ
	var preColor=(colorMax-colorMin)/(log10(max)-log10(min));
	for(var i=0,n=tagCnt.length; i<n; i++){
		var diff=log10(tagCnt[i][1])-log10(min);
		var fontSize=Math.ceil((preFont*diff+fontMin)*10)/10;//小数第1位以下切り捨て
		var color=("0"+Math.floor(preColor*diff+colorMin).toString(16)).slice(-2);//カラーの計算(カウントが大きいほど明るい)
		res[i]=	'<a href="javascript:void(0)" style="font-size:'+fontSize+'pt;color:#'+color+color+color+'"'+
				' onclick="getTagInfo(this,\''+tagCnt[i][0]+'\',0)" title="計'+tagCnt[i][1]+'個(消去済みを含む)/クリックで動画リスト表示">'+tagCnt[i][0]+'</a>';
	}
	ele.innerHTML="<div>"+res.join('　\n')+"</div>";
}
/*-----------------------------------------------------------------------------
実際のHTML出力処理
-----------------------------------------------------------------------------*/
function makeCacheList(){
	//フォルダの階層を再現したオブジェクトを返す
	//{フォルダ名:{'':[そのディレクトリの動画情報配列],サブフォルダ名:{〃},...}
	function buildDir(list){
		var dir={};
		var tmpArr=toArray(list);
		for(var i=0,n=dirList.length;i<n;i++){
			var tmpObj=dir;
			var path=dirList[i].split('/'),parentPath=[],cnt=0;
			while(path.length>0){
				parentPath[cnt++]=path[0];
				if(!tmpObj[path[0]]){
					tmpObj[path[0]]={
						'':tmpArr.childFillter(2,parentPath.join('/')).childXSort(SORT_FLAG[0],SORT_FLAG[1])
							//["smXXX","title","folder","Byte","Time"]
					};
				}
				tmpObj=tmpObj[path[0]];
				path=path.slice(1);
			}
		}
		return dir;//.toSource().replace(/\\u(\w{4})/ig,function(all,code){return String.fromCharCode(parseInt(code,16))});
	}
	//階層を再帰的にHTMLコード化するための関数群
	function initTable(list){
		var tmpTable=[],tmpLabel=[],cnt=0;
		for(var i in list){
			var buf=makeTable(list[i],i,true);
			tmpLabel[cnt]=buf[0];
			tmpTable[cnt++]=buf[1];
		}
		return [tmpLabel.join(''),tmpTable.join('')];
	}
	function makeTable(list,folderName,isRootChild){
		var tmpStr=[],folderTmp=[],cnt=0;
		var parent=getTableCode(list[''],folderName,isRootChild);
		for(var i in list){
			if(i!=''){
				var buf=makeTable(list[i],folderName+'/'+i);
				folderTmp[cnt]=buf[0];
				tmpStr[cnt++]="<tr><td colspan='5' style='width:100%;margin:5px'>"+buf[1]+"</td></tr>";
			}
		}
		return [
			parent[0].ins({subFolder:folderTmp.length==0?'':"<ul style='"+((folderName in openedList)?'':"display:none")+"'>"+folderTmp.join('')+"</ul>"}),
			parent[1].ins({subFolder:tmpStr.length==0?'':"<tbody>"+tmpStr.join('')+"</tbody>"})
			];
	}
	function getTableCode(list,folder,isRootChild){
		var tmp=[],tmpCnt=0;
		var folderName=(folder!='' ? folder : "キャッシュフォルダ");
		var tableDisp = (folderName in openedList) ? '' : "display:none";
		var folderChild=list;
		var folderParent=("<li class='menuLabel'><a href='javascript:void(0)' onclick='viewTable("+tableCnt+")'>{folderName}{fileCnt}</a>{subFolder}</li>").ins(
			{
				folderName	:	folderName.split('/').slice(-1),
				fileCnt		:	"</td><td class='files'>("+(folderChild.length||"N/A")+")"
			}
		);
		tmp[tmpCnt++]=("<table class='label'"+(isRootChild?" style='"+tableDisp+"'":'')+"><tr><td><a href='javascript:void(0)' onclick='viewTable("+tableCnt+")'>{folderName}</a>{fileCnt}</td></tr></table>").ins(
			{
				folderName	:	folderName.split('/').slice(-1),
				fileCnt		:	(folderChild.length>0?"</td><td class='files'>("+fileCount(folderChild.length)+")":'')
			}
		);
		
		tmp[tmpCnt++]="<table summary='"+folderName+"' class='flvList"+
			(folderChild.length>0?" sortable":'')+(tableDisp!=''?" hiddenList":'')+
			"' style='"+ tableDisp +";'>{subFolder}<tbody>";
		//動画リストの生成（非表示時スキップ）
		if(tableDisp==''&&folderChild.length>0){
			tmp[tmpCnt++]=TEMP_TH;
			for(var cnt=0,m=folderChild.length;cnt<m;cnt++){
				var k=folderChild[cnt][0];
				var d=new Date();
				d.setTime(folderChild[cnt][4]*1000);
				tmp[tmpCnt++]=TEMP_TABLE.ins(
					{
						className	:	(/low$/.test(k)?"lowMovie":(cnt%2==0?'odd':'even')),//lowモードのflvか,奇数番目か
						href		:	k.replace("low", ''),
						dispHref	:	k,
						rightHref	:	getRightId(k),
						folder		:	folderName,
						tableCnt	:	tableCnt,
						title		:	(folderChild[cnt][1]!='' ? folderChild[cnt][1] : "<a href='javascript:void(0)' onclick=\"getTitle(this)\">タイトルを取得</a>"),
						length		:	numViewCh(folderChild[cnt][3]),
						time		:	(
											[(d.getFullYear()+'').slice(-2),d.getMonth()+1,d.getDate()].join('/')+
											' '+[d.getHours(),d.getMinutes()].join(':')
										).replace(/\d+/g,function(num){ return ('0'+num).slice(-2) }),//数字を2桁にそろえる
						fileType	:	EXT_ICON_USE?' '+extList[k]:'',
						tag			:	getTagHTML(k.replace("low", ''))
					}
				);
			}
		}
		tmp[tmpCnt++]="</tbody></table>";
		tableCnt++;
		return [folderParent,tmp.join('')];
	}
	//以下実際の処理
	start = new Date;
	var folderList='';
	//情報リストを強制的に更新
	//eval("tempList={};"+Ajax("/cache/ajax",function(){},true));
	getDefaultList();
	//拡張子リストを取得
	if(!window.extList)getExt();
	//タグリストを取得
	if(!window.tagList)getTag();
	
	// [nl] 設定値をパース
	var setting = getCookie();
	if (typeof setting == "undefined")
		setting = option;
	//動画削除のためにリンクを踏んだ場合、キャッシュ画面を表示しない（高速化）
	var q=parseQuery(setting);
	if(q["skip_when_del"]&&/^http:\/\/www\.nicovideo\.jp\/watch\/[a-z]{2}\d+/.test(document.referrer)){
		var mes="<h1>キャッシュ削除のためのアクセスと判断</h1><p>キャッシュリストの表示を省略しました（参照元："+
				document.referrer+
				"）<br><a href='./'>キャッシュ表示画面を表示</a></p>";
		document.write(mes);
		AUTO_SAVE=false;
		return;
	}
	var tmp = prepareOptions(setting);
	var css = tmp[0];
	var openedList = tmp[1];
	
	var tableCnt=0;
//一時ファイルのHTMLデータを生成-----------------------------------------------
	var tstr = [];
	if (typeof tempList != "undefined")
	{
		var bufCnt=0,cnt=0;
		var tmpArr=toArray(tempList);
		var isOpened=("一時ファイル" in openedList) ? '' : "display:none";
		folderList+="<li class='menuLabel'>"+(tmpArr.length>0?"<a href='javascript:void(0)' onclick='viewTable("+tableCnt+")'>":'')+"一時ファイル("+(tmpArr.length||"N/A")+")"+(tmpArr.length>0?"</a>":'')+"</li>";
		tstr[bufCnt++]="<table class='label' style='"+isOpened+"'><tr><td>"+(tmpArr.length>0?"<a href='javascript:void(0)' onclick='viewTable("+tableCnt+")'>":'')+"一時ファイル"+(tmpArr.length>0?"</a></td><td class='files'>("+fileCount(tmpArr.length)+")":'')+"</td></tr></table>";
		tstr[bufCnt++]="<table summary='一時ファイル' style='"+isOpened+"' class='flvList sortable'>";
		tstr[bufCnt++]="<tr class='tableHeader'><th class='unsortable multi' onclick='multiCheck(this)'><span class='bt_select_off'>選</span></th><th class='movieId'>動画番号</th><th class='title' style='text-align:center'>タイトル</th><th class='loaded'>ロード済みサイズ</th></tr>";
		for (var i=0,n=tmpArr.length;i<n;i++){
			var k=tmpArr[i][0];
			var nowDL = tmpArr[i][4];
			var percentDL = "";
			if (nowDL && tmpArr[i][3] > 1)
				percentDL = parseInt(tmpArr[i][2] / tmpArr[i][3] * 100);
			
				tstr[bufCnt++]=TEMP_TEMP_TABLE.ins(
				{
					className	:	(/low$/.test(k)?"lowMovie":(cnt%2==0?'odd':'even')),//lowモードのflvか,奇数番目か
					href		:	k.replace("low", ""),
					dispHref	:	k,
					rightHref	:	getRightId(k),
					status		:	(nowDL ? ("[DL中 (" + percentDL + "%)] ")  : ""),
					del			:	(nowDL ? "" : "<span onclick='delFLV("+tableCnt+",\""+k+"\",true)' class='command'>"+_IMG_DEL+"</span>"),
					title		:	(tmpArr[i][1]!='' ? tmpArr[i][1] : 'N/A'),
					loaded		:	numViewCh(tmpArr[i][2]),
					fileType	:	EXT_ICON_USE?' '+extList[k]:'',
					tag			:	getTagHTML(k.replace("low", ''))
				}
			);
			cnt++;
			}
			tstr[bufCnt++]="</table>";
			tableCnt++;
	}
	tstr=tstr.join('');
//フォルダごとにキャッシュフォルダのHTMLデータを生成-----------------------------
	var cstr='';
	if (typeof cacheList != "undefined"){
		pathList=buildDir(cacheList);
		var buf=initTable(pathList);
		folderList+=buf[0];
		cstr=buf[1];
	}
//HTMLへのデータの埋め込み->HTMLの出力-------------------------------------------
	var html = css + 
		("<div id='root'><table class='header'><tr><td id='topLink'><a href='../?g=all'>Top</a>/<a href='javascript:void(0)' onclick='dispOption()'>Option</a>/"+
		"<a href='javascript:void(0)' onclick='var d=document.getById(\"view_cookie\");if(!disp(d)){var ck=document.cookie.match(/[qm]=[^;]+;/g);if(ck)d.innerHTML=ck.join(\"<br>\")}'>Cookie</a>/"+
		"<a href='javascript:void(0)' onclick='viewMemo()'>Memo</a>/"+
		"<a href='javascript:void(0)' onclick='var d=document.getById(\"same_size\");if(!disp(d))sameFile(d)'>sameFile</a>/"+
		"<a href='javascript:void(0)' onclick='viewSearch()'>Search</a>/"+
		"Multi( <a href='javascript:void(0)' onclick='doMulti(1)'>"+_IMG_DEL+"</a>・"+
		"<a href='javascript:void(0)' onclick='doMulti(2)'>"+_IMG_MOVE+"</a> )/"+
		"<a href='javascript:void(0)' onclick='var d=document.getById(\"limit_view\");if(!disp(d))cacheLimit(d)'>cacheLimit</a>/"+
		"<a href='javascript:void(0)' onclick='var d=document.getById(\"tag_cloud\");if(!disp(d))tagCloud(d)'>tagCloud</a>/"+
		"<a href='javascript:void(0)' onclick='autoMove()'>autoMove</a>/<a href='javascript:void(0)' onclick='disp(document.getById(\"help\"))'>Help</a>"+
		"</td></tr></table>"+
		"<div id='view_cookie' style='display:none'></div>"+
		"<div id='option' style='display:none'>{option}</div>"+
		"<div id='memo' style='display:none'></div>"+
		"<div id='same_size' style='display:none'></div>"+
		"<div id='search' style='display:none'></div>"+
		"<div id='help' style='display:none'>"+
		"<h1>バージョン情報</h1><p>{version} &amp; ListX {listVar}</p>"+
		"<h1>処理時間</h1><p id='timemake'></p>"+
		"<h1>メニューの解説</h1><dl>"+
		"<dt>Top：</dt><dd>ニコニコ動画トップページへのリンク</dd>"+
		"<dt>Option：</dt><dd>各種オプションを設定</dd>"+
		"<dt>Cookie：</dt><dd>設定を保存しているCookieを表示</dd>"+
		"<dt>Memo：</dt><dd>動画idをメモしておくことが出来る</dd>"+
		"<dt>sameFile：</dt><dd>同じサイズや低画質(low)と通常の動画などダブっている動画をリストアップ</dd>"+
		"<dt>Search：</dt><dd>動画タイトルを検索し、ヒットした動画をリストアップ</dd>"+
		"<dt>Multi：</dt><dd>チェックボックス（選択の行に存在）を入れた複数の動画に対して一括して削除・移動</dd>"+
		"<dt>autoMove：</dt><dd>autoMoveRule.xmlのルールに従って動画を自動的に特定のフォルダへ移動</dd>"+
		"<dt>cacheLimit：</dt><dd>cacheLimitRule.xmlのルールに従って指定容量以上の場合に削除する動画を提案</dd>"+
		"<dt>tagCloud：</dt><dd>タグ出現数に比例した文字サイズと色でタグの一覧を表示（クリックでそのタグの動画を検索可能）</dd>"+
		"<dt>Help：</dt><dd>このヘルプ画面を表示</dd>"+
		"</dl></div>"+
		"<div id='limit_view' style='display:none'></div>"+
		"<div id='tag_cloud' style='display:none'></div>"+
		"</div>"+
		"<ul id='folderList'>{folderList}</ul>"+
		"<div id='mainBox'>{tmpFile}{cacheFile}</div>"+
		"<div id='dialog' class='dialog' style='display:none'></div>"+
		"<div id='thum' style='display:none'></div>{script}").ins(
			{
				version		:	ncversion,//.replace(/NicoCache/g,"NC"),
				listVar		:	LISTX_VERSION,
				folderList	:	folderList,
				tmpFile		:	(tstr||''),
				cacheFile	:	(cstr||"<h2 class='header'>キャッシュはまだありません。</h2>"),
				option		:	"<form action='./' id='optionForm' onsubmit='return false'><ul>"+
								"<li class='opLabel'>リスト表示のスキップ（設定はリロード後反映）：<ul>"+
									"<li><input type='checkbox' name='skip_when_del'>削除のためのアクセス時にキャッシュリストを表示しない（高速化可能）</li></ul></li>"+
								"<li class='opLabel'>アイコンの表示（設定はリロード後反映・OFFで低負荷かつ高速化可能）：<ul>"+
									"<li><input type='checkbox' name='img_use'>操作ボタンのアイコンを使用</li>"+
									"<li><input type='checkbox' name='ext_icon_use'>拡張子ごとのアイコンを使用</li></ul></li>"+
								"<li class='opLabel'>サムネイル：<ul>"+
									"<li><input type='radio' name='use_ex_thum' value='0'>標準のサムネイルを利用（最も低負荷）</li>"+
									"<li><input type='radio' name='use_ex_thum' value='1'>外部貼り付け用サムネイルを利用（iframe使用につき多少の負荷）</li>"+
									"<li><input type='radio' name='use_ex_thum' value='2'>自前の外部プレイヤー（player.html）を利用する（iframe+Flash使用につき高負荷）</li></ul></li>"+
								"<li class='opLabel'>ダイアログによる確認：<ul><li><select name='dialog_show'>"+
									"<option value='always'>常に尋ねる</option><option value='multi'>複数動画を操作するときのみ尋ねる</option>"+
									"<option value='never'>常に尋ねない</option></select></li></ul></li>"+
								"<li class='opLabel'>タイトルの表示位置：<ul><li><select name='title_align'>"+
									"<option value='left'>左</option><option value='center'>中央</option>"+
									"<option value='right'>右</option></select></li></ul></li>"+
								"<li class='opLabel'>タイトルをクリックした時に編集するか：<ul><li><select name='title_edit'>"+
									"<option value='none'>編集しない</option><option value='click'>クリックで編集</option>"+
									"<option value='dblclick'>ダブルクリックで編集</option></select></li></ul></li>"+
								"<li class='opLabel'>表示する列：<ul>"+
									"<li><input type='checkbox' name='multi'>選択</li>"+
									"<li><input type='checkbox' name='movieId'>動画番号</li><li><input type='checkbox' name='title'>タイトル</li>"+
									"<li><input type='checkbox' name='time'>更新日時</li><li><input type='checkbox' name='loaded'>ロード済みサイズ</li></ul></li>"+
								"<li class='opLabel'>デフォルトのソート状態：<ul><li><select name='sort_status'>"+
									"<option value='movieId_down'>動画番号降順</option><option value='movieId_up'>動画番号昇順</option>"+
									"<option value='title_down'>タイトル降順</option><option value='title_up'>タイトル昇順</option>"+
									"<option value='folder_down'>フォルダ降順</option><option value='folder_up'>フォルダ昇順</option>"+
									"<option value='size_down'>ファイルサイズ降順</option><option>ファイルサイズ昇順</option>"+
									"<option value='time_down'>更新日時降順</option><option value='time_up'>更新日時昇順</option></select></li></ul></li>"+
								"<li class='opLabel'>ソート順序の変更：<ul>"+
									"<li>文字種ごとのソートの順番（数字,半角,かな,その他の全角）：<input type='text' name='sort_rank'></li>"+
									"<li>最優先でソートする文字（この順序でソートされる）：<input type='text' name='sort_char'></li>"+
									"<li>カタカナをひらがなとしてソートする：<input type='checkbox' name='kana_fix'></li></ul></li>"+
								(COOKIE_OK?
									"<li class='opLabel'>Cookie：<ul>"+
										"<li><input type='checkbox' name='autosave'>ページを閉じたり、移動した時にcookieへ自動的に状態を保存する</li>"+
										"<li><button onclick='return makeOption(this.form,true)'>Cookieに保存する</button>　"+
										"<button onclick='return delCookie()'>Cookieを削除する</button></li>"+
									"</ul></li>":'')+
								"<li class='opLabel'>設定画面を閉じる・変更をキャンセル・Cookieを使わないオプションの保存：<ul>"+
									"<li><button onclick='return refreshOption(this.form)'>設定を反映</button>　"+
									"<button onclick='return dispOption()'>キャンセル</button>　/　"+
									"<button onclick='return makeOption(this.form)'>設定保存用文字列生成</button></li>"+
								"</li></ul></form>"+
								"<form style='display:none' id='optionField' onsubmit='return false'>"+
									"デフォルト設定用のテキスト：　<input type='text' onclick='this.focus();this.select()' size='40'>"+
									"<p>上記の文字列をlist.jsの1行目にコピー＆ペーストすることによって、"+
									"このページを開いたときの各種設定とフォルダの開閉を保存できます。</p>"+
								"</form>",
				script		:	"<script type='text/javascript'>setOptionPage(\""+setting+"\");sortables_init();refreshOption(document.getById('optionForm'));</script>"
			}
		);
	rap = new Date();
	document.write(html);
}
//レンダリングタイムの表示
function viewRecord(times){
	if(!!window.rap){
		var end=new Date();
		document.getElementById('timemake').innerHTML = "HTMLの生成:"+(rap-start) + "msec　|　HTMLの解釈:" +(end-rap)+ "msec　|　トータル：" + (end-start)+"msec";
	}else if(!times){
		setTimeout(function(){viewRecord(1)},0);
	}
}
/*-----------------------------------------------------------------------------
イベント
-----------------------------------------------------------------------------*/
addEvent(window,"load",viewRecord);
addEvent(window,"unload",autoSave);
addEvent(document,"keydown",keyChange);
addEvent(document,"keyup",keyChange);
function keyChange(e){
	PUSHED_SHIFT=(e||event).shiftKey;
	var dia=document.getElementById("thum");
	if(PUSHED_SHIFT&&dia&&dia.style.display!="hidden"){
		var id=(dia.lastChild?dia.lastChild.title:null);
		if(id){
			viewThum(id,2);
		}
	}
}
/*-----------------------------------------------------------------------------
以下、sortable.jsの改造版sortable_ja.jsのListX向け改造版
-----------------------------------------------------------------------------*/

/*
Table sorting script  by Joost de Valk, check it out at http://www.joostdevalk.nl/code/sortable-table/.
Based on a script from http://www.kryogenix.org/code/browser/sorttable/.
Distributed under the MIT license: http://www.kryogenix.org/code/browser/licence.html .

Copyright (c) 1997-2007 Stuart Langridge, Joost de Valk.

Version 1.5.7
2007/11/02 mod by ListX
*/
(function(){
/* You can change these values */
var normal_txt = '\u2195';
var up_txt='\u2191';
var down_txt='\u2193';

/* Don't change anything below this unless you know what you're doing */
var SORT_COLUMN_INDEX;
var thead = false;

window.sortables_init=function() {
	// Find all tables with class sortable and make them sortable
	if (!document.getElementsByTagName) return;
	var tbls = document.getElementsByTagName("table");
	for (var ti=0;ti<tbls.length;ti++) {
		var thisTbl = tbls[ti];
		window.ts_makeSortable(thisTbl);
	}
}
//addEvent(window, "load", window.sortables_init);//makeCacheListのHTML出力にscriptとして埋め込んだ

window.ts_makeSortable=function(t) {
	t.className=t.className+'';
	if (t.className.indexOf("sortable")==-1||t.className.indexOf("hiddenList")!=-1){
		return;
	}
	t.className=t.className.replace(/\s?sortable/,'');
	var firstRow;
	if (t.rows && t.rows.length > 0) {
		firstRow = t.lastChild.rows[0];
	}
	if (!firstRow) return;
	
	// We have a first row: assume it's the header, and make its contents clickable links
	for (var i=0;i<firstRow.cells.length;i++) {
		var cell = firstRow.cells[i];
		var txt = ts_getInnerText(cell);
		if (cell.className != "unsortable" && (cell.className+'').indexOf("unsortable") == -1) {
			cell.innerHTML = '<a href="#" class="sortheader" onclick="ts_resortTable(this, '+i+');return false">'+txt+'<span class="sortarrow">&nbsp;&nbsp;'+normal_txt+'</span></a>';
		}
	}
}

function ts_getInnerText(el) {
	if (typeof el == "string") return el;
	if (typeof el == "undefined") { return el };
	if (el.innerText) return el.innerText;	//Not needed but it is faster
	var str = "";
	
	var cs = el.childNodes;
	var l = cs.length;
	for (var i = 0; i < l; i++) {
		switch (cs[i].nodeType) {
			case 1: //ELEMENT_NODE
				str += ts_getInnerText(cs[i]);
				break;
			case 3:	//TEXT_NODE
				str += cs[i].nodeValue;
				break;
		}
	}
	return str;
}

window.ts_resortTable=function(lnk, clid) {
	function trim(s) {
		return (s+'').replace(/^\s+|\s+$/g, "");
	}
	var start = new Date;
	var span;
	for (var ci=0,n=lnk.childNodes.length; ci<n; ci++) {
		if (lnk.childNodes[ci].tagName && lnk.childNodes[ci].tagName.toLowerCase() == 'span') span = lnk.childNodes[ci];
	}
	var spantext = ts_getInnerText(span);
	var td = lnk.parentNode;
	var column = clid || td.cellIndex;
	var t = getParent(td,'TABLE');
	var tbodies = t.lastChild;
	// Work out a type for the column
	if (t.rows.length <= 1) return;
	var itm = "";
	var i = 0, n=t.tBodies[0].rows.length;
	while (itm == "" && i < n) {
		var itm = trim(ts_getInnerText(t.tBodies[0].rows[i].cells[column]));
		if ((t.tBodies[0].rows[i].cells[column]&&t.tBodies[0].rows[i].cells[column].tagName == "TH") || t.tBodies[0].rows[i].className == "unsortable" || t.tBodies[0].rows[i].className.indexOf("unsortable") != -1 || itm.length == 0) {
			itm = "";
		}
		i++;
	}
	if (itm == "") return; 
	var sortfn = ts_sort_default;//ts_sort_caseinsensitive;
	SORT_COLUMN_INDEX = column;
	// [nl] ソート別に個別のを設定してみる
	if (SORT_COLUMN_INDEX == 1){
		//Shift押していない場合は数字順にソート
		if(!PUSHED_SHIFT){
			sortfn = compare_numeric_id;
		}else{
			sortfn = ts_sort_movieId;
		}
	}
	// 検索orタイトルのときは
	else if (SORT_COLUMN_INDEX == 2)
	{
		sortfn = ts_sort_cache;
		NL_SORT_COL = 0;
	}
	// 更新日時のときは
	else if (SORT_COLUMN_INDEX == 3)
	{
		sortfn = ts_sort_cache;
		NL_SORT_COL = 3;
	}
	
	// 大きさのときは
	else if (SORT_COLUMN_INDEX == 4)
	{
		sortfn = ts_sort_cache;
		NL_SORT_COL = 2;
	}
	var firstRow = new Array();
	var newRows = new Array();
	for (var k=0,n=t.tBodies.length; k<n; k++) {
		for (i=0,m=tbodies.rows[0].length; i<m; i++) { 
			firstRow[i] = tbodies.rows[0][i]; 
		}
	}
	if (!thead) {
		// Skip the first row
		for (var k=0,n=t.tBodies.length; k<n; k++) {
			for (var j=1,m=t.tBodies[k].rows.length; j<m; j++) { 
				newRows[j-1] = t.tBodies[k].rows[j];
			}
		}
	} else {
		// Do NOT skip the first row
		for (var k=0,n=t.tBodies.length; k<n; k++) {
			for (var j=0,m=t.tBodies[k].rows.length; j<m; j++) { 
				newRows[j] = t.tBodies[k].rows[j];
			}
		}
	}
	newRows.sort(sortfn);
	var ARROW;
	if (span.getAttribute("sortdir") == 'down') {
			ARROW = '&nbsp;&nbsp;'+up_txt;
			newRows.reverse();
			span.setAttribute('sortdir','up');
	} else {
			ARROW = '&nbsp;&nbsp;'+down_txt;
			span.setAttribute('sortdir','down');
	} 
    // We appendChild rows that already exist to the tbody, so it moves them rather than creating new ones
    // don't do sortbottom rows
    for (var i=0,n=newRows.length; i<n; i++) {
    		tbodies.appendChild(newRows[i]);
	}
	span.innerHTML = ARROW;

	//alert((new Date)-start);
}

function getParent(el, pTagName) {
	if (el == null) {
		return null;
	} else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase()) {
		return el;
	} else {
		return getParent(el.parentNode, pTagName);
	}
}

// [nl] 独自の比較関数。多少手抜き
function ts_sort_movieId(a,b) {
	var a=String(a.id),
		b=String(b.id),
		aLow=a.indexOf("low")!=-1,
		bLow=b.indexOf("low")!=-1;
	if(aLow||bLow){
		return (aLow&&bLow)?0:(aLow?-1:1);
	}
	else{
		var aa=a.slice(0,2),
			bb=b.slice(0,2);
		return (aa<bb)?-1:
				(aa>bb)?1:compare_numeric(a,b);
	}
}

// nl_mod2版を変更し文字コード補正ONに
function ts_sort_cache(a,b)
{
	//ソート順を変更するときの判定用パターン
	var reg=[
		/\d/,		//数字
		/[ -~｡-ﾟ]/,	//半角文字（数字除く）
		/[ぁ-ん]/,		//かな
		/[^ -~｡-ﾟ]/,	//全角文字
		/./					//その他
		];
	//文字とパターンを照合し、そのソート順序を取得
	function getSortRank(str){
		//個別指定の順序をチェック
		if(!!SORT_CHAR){
			var tmp=SORT_CHAR.indexOf(str);
			if(tmp!=-1){
				return -(SORT_CHAR.length-tmp);
			}
		}
		for(var i=0,n=reg.length,tmp;i<n;i++){
			if(reg[i].test(str)){
				return SORT_RANK[i];
			}
		}
		return SORT_RANK.length;
	}
	//与えられた2つの文字列をSORT_RANKにしたがって評価する
	function sortBySortRank(a,b){
		//document.title=(new Array((document.title.split('.').length+1)%101)).join('.');
		for(var i=0,n=Math.min(a.length,b.length);i<n;i++){
			var charA=a.charAt(i),
				charB=b.charAt(i),
				_a=getSortRank(charA),
				_b=getSortRank(charB);
			if(_a==_b){
				//同じ文字種でも異なる文字なら普通に評価
				if(charA!=charB){
					break;
				}
				continue;
			}
			else if(_a<_b){
				return -1;
			}
			return 1;
		}
		return (aa<bb)?-1:
				(aa>bb)?1:0;
	}
	
	function kana_fix(str){
		return str.replace(/[\u30a1-\u30f4]/g,function(c){//ァ(\u30a1)からヴ(\u30f4)まで
			return String.fromCharCode(c.charCodeAt(0)-96);//ァ(\u30a1)-ぁ(\u3041)=96(0x60)
		});
	}
	var aa=cacheList[a.id][NL_SORT_COL];//["smXXX","title","folder","Byte","Time"]
	var bb=cacheList[b.id][NL_SORT_COL];
	//document.title=NL_SORT_COL+'--'+cacheList[a.id];
	if(SORT_COLUMN_INDEX==2){
		if(KANA_FIX){//タイトルのみに適応
			aa=kana_fix(aa);
			bb=kana_fix(bb);
		}
		return sortBySortRank(aa,bb);
	}
	return (aa<bb)?-1:
			(aa>bb)?1:aa-bb;
}

function compare_numeric(a,b) {
	var an=(parseFloat(String(a).match(/\d+/))||0),
		bn=(parseFloat(String(b).match(/\d+/))||0);
	return (an<bn)?-1:
			(an>bn)?1:0;
}
function compare_numeric_id(a,b) {
	var an=(parseFloat(String(a.id).match(/\d+/))||0),
		bn=(parseFloat(String(b.id).match(/\d+/))||0);
	return (an<bn)?-1:
			(an>bn)?1:0;
}
function ts_sort_default(a,b) {
	aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);
	bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);
	return (aa<bb)?-1:
			(aa>bb)?1:0;
}
})();